IMPLEMENTATION MODULE BattleScreen;

(*Deze voleddige module samen met al haar toebehoren( pics, waves) is gemaakt door Yannick*)

    FROM IO IMPORT RdChar, WrChar, WrStr, RdStr, WrLn, RdLn, RdCard, WrCard, RdInt, WrInt, RdReal, WrReal, WrFixReal, RdBool, WrBool, RdKey, KeyPressed;
    FROM RealMath IMPORT sqrt, exp, sin, cos, tan, arcsin, arccos, arctan, power, round, pi;
    FROM Lib IMPORT Delay; (* Wait n milliseconds *)
    FROM Graph IMPORT Init, Line, Rectangle, Circle, Disc, Polygon, RawOutText, _clrBLACK, _clrBLUE, _clrGREEN, _clrCYAN, _clrRED, _clrMAGENTA;
    FROM Graph IMPORT _clrBROWN, _clrWHITE, _clrGRAY, _clrLIGHTBLUE, _clrLIGHTGREEN, _clrLIGHTCYAN, _clrLIGHTRED, _clrLIGHTMAGENTA, _clrLIGHTYELLOW, _clrBRIGHTWHITE;
    FROM Graph IMPORT Plot, GetImage, PutImage, _GPSET, Point, SetBkColor, ClearScreen;
    FROM StandardMouse IMPORT InitMouseGraphWindow, UpdateMouse, GetMouseX, GetMouseY, MouseButton, IsButtonPressed;
    FROM ModifiedStandardBitmap IMPORT BITMAP_SIZE, DIGIT_SIZE, BitmapEn, DrawBitmap, DrawNumber, DrawDigit, DrawBitmapFile, DrawSavedBitmap;
    FROM StandardLib IMPORT StrLength, StrCompare, StrCopy, StrConcatenate, StrAr, RandomCard, gPseudoRandom;
    FROM SYSTEM IMPORT NEW, DISPOSE;
    FROM WholeStr IMPORT CardToStr;
    FROM Str IMPORT Insert, Match;
    FROM StandardSound IMPORT SoundEventEn, InitSound, PlaySoundEvent;
    FROM DefineType IMPORT CountryRe;

    CONST SCREEN_HIGHT		= 	700;   (* constants *)
    	  SCREEN_WIDTH		=       875;
	  IMAGE_SIZE 		=	70;    (*de grootte van 1 vakje*)
	  MENU_SIZE 		= 	174;   (*de grootte van de menubalk*)
	  NBR_ROWS		=  	(SCREEN_HIGHT/IMAGE_SIZE);
	  NBR_COLUMNS		=       ( (SCREEN_WIDTH - MENU_SIZE) / IMAGE_SIZE);
	  DELAY_TIME		=	700;
	
    TYPE ColourSb = [0..16]; (* for colour codes, see Graph.def. Color=16 means transparant *)
	
	 UnitRc = RECORD
		fileName, name			: ARRAY [1..16] OF CHAR;
		health, healthPerUnit, attack, movesThisTurn, movesPerTurn, range,
		rangedAttack, men , ammo, id	: CARDINAL;
		side				: [1..2]
	 END;
	
	 SoortTileRc  = RECORD
		 	id	:		CARDINAL;                       (* number of saved bitmap *)
			toegankelijk, beschietbaar:		BOOLEAN;
		END;
		
	 SpeelveldTileRc= RECORD
	 	rij 				: [1..NBR_ROWS]   ;
		kollom 				: [1..NBR_COLUMNS]  ;
		inhoud	 			: POINTER TO UnitRc ;
		soort				: POINTER TO SoortTileRc;
	 END;
	 Tekst = ARRAY [1..25] OF CHAR;

    VAR	 gColorMap	: 			ARRAY['a'..'z'] OF ColourSb;    (* variable-declarations *)
	 GrasRc, BridgeRc, RivierRc, RockRc	:	 		SoortTileRc;
	 Speelveld				:			ARRAY[1..NBR_COLUMNS],[1..NBR_ROWS] OF SpeelveldTileRc;
	 ActiveTile				:                       SpeelveldTileRc;
(*	 art1, art2, cav1, cav2, inf1, inf2, pea1, pea2		:			UnitRc;    *)
	 Attacker, Defender, Player, Winner	:			CARDINAL;
	 FightOver				:			BOOLEAN;
	 TekstVak                               :                       ARRAY [1..6] OF RECORD
	 		tekst	:		Tekst;
	                speler  :		CARDINAL;               (* bepaalt de kleur van de tekst*)
			END;
	 NieuweTekst				:			Tekst;
	 i		:			CARDINAL;
         BattleScreenUnitsArr			:			ARRAY [1..2], UnitsEn OF UnitRc;
	
(*		TEKEN-PROCEDURES		*)
(************************************************)	
    PROCEDURE TekenTile(NbrTile : SpeelveldTileRc);                         (* procedure die tiles tekent *)
    	BEGIN	
    	DrawSavedBitmap((NbrTile.kollom-1) *IMAGE_SIZE+1, (NbrTile.rij-1) *IMAGE_SIZE+1, NbrTile.soort^.id);
	END TekenTile;
	

	
    PROCEDURE TekenUnit(Unit : UnitRc;VAR NbrTile : SpeelveldTileRc);
    	VAR width, hight:			CARDINAL;
    	BEGIN                                                			(* de bitmaps worden niet gesaved omdat zo de achtergrong kan bewaard worden *)
		Unit.id := DrawBitmapFile((NbrTile.kollom-1) *IMAGE_SIZE+1, (NbrTile.rij-1) *IMAGE_SIZE+2, Unit.fileName, width, hight);  	
		NEW(NbrTile.inhoud);
		NbrTile.inhoud^:=Unit;
	END TekenUnit;
	
	
	
	
    PROCEDURE TekenDust(NbrTile : SpeelveldTileRc);
    	VAR id, width, hight	:		CARDINAL;
    	BEGIN
		id := DrawBitmapFile((NbrTile.kollom-1) *IMAGE_SIZE+1, (NbrTile.rij-1) *IMAGE_SIZE+2, "BSUnits/dust.bmp", width, hight);
	END TekenDust;
	
	
		
	
    PROCEDURE TekenKnop(Startx, Starty, Eindx, Eindy : CARDINAL; ColourKnop, ColourTekst : CARDINAL; Tekst:ARRAY OF CHAR);    (*   procedure om een rechthoekige knop  *)
	VAR oldCol		:		CARDINAL;                                                                     (* te tekenen met de tekst in het midden *)
	BEGIN
	  	oldCol:=SetBkColor(ColourKnop);
	  	Rectangle (Startx, Starty, Eindx, Eindy, ColourKnop, TRUE);
		Rectangle (Startx, Starty, Eindx, Eindy, _clrBLACK, FALSE);
	      	RawOutText (Startx + ( (Eindx-Startx-VAL(CARDINAL, VAL(REAL ,StrLength(Tekst))*7.5)) / 2), Starty + ((Eindy-Starty-14)/2), ColourTekst, Tekst);
	    	oldCol:=SetBkColor(oldCol);
    	END TekenKnop;
	
	

    PROCEDURE TekenSelectUnit(Tile : SpeelveldTileRc; Colour: CARDINAL);  (* tekent een virkant om de geselecteerde unit *)
    	BEGIN
		Rectangle((Tile.kollom-1)*IMAGE_SIZE+1, (Tile.rij-1)*IMAGE_SIZE+1, Tile.kollom*IMAGE_SIZE+1,Tile.rij*IMAGE_SIZE+1, Colour, FALSE);
	END TekenSelectUnit;
	
	
	
    PROCEDURE TekenMoveOptions(NbrTile : SpeelveldTileRc; Colour, ColourAttack: CARDINAL); (*tekent de opties die de unit heeft*)
    	VAR i		:			CARDINAL;                                  (*  om te bewegen en aan te vallen  *)
	BEGIN   	
		i:=1;
		WHILE (NbrTile.kollom>i) AND (Speelveld[NbrTile.kollom-i][NbrTile.rij].inhoud=NIL)
		AND (i<=NbrTile.inhoud^.movesThisTurn) AND (Speelveld[NbrTile.kollom-i][NbrTile.rij].soort^.toegankelijk) DO                                              (* de WHILE kijkt na ofdat de tile toegankelijk *)
			Rectangle((Speelveld[NbrTile.kollom-i][NbrTile.rij].kollom-1)*IMAGE_SIZE+1, (Speelveld[NbrTile.kollom][NbrTile.rij].rij-1)*IMAGE_SIZE+1,          (*        is voor de geselecteerde unit         *)
				 Speelveld[NbrTile.kollom-i][NbrTile.rij].kollom*IMAGE_SIZE+1,Speelveld[NbrTile.kollom][NbrTile.rij].rij*IMAGE_SIZE+1, Colour, FALSE);
			INC(i);
		END;
		IF (NbrTile.kollom>i) AND (Speelveld[NbrTile.kollom-i][NbrTile.rij].inhoud#NIL) AND (Speelveld[NbrTile.kollom-i][NbrTile.rij].inhoud^.side#Player) THEN         (* de IF gaat na ofdat de Tile kan aangevallen worden *)
			Rectangle((Speelveld[NbrTile.kollom-i][NbrTile.rij].kollom-1)*IMAGE_SIZE+1, (Speelveld[NbrTile.kollom][NbrTile.rij].rij-1)*IMAGE_SIZE+1,
				 Speelveld[NbrTile.kollom-i][NbrTile.rij].kollom*IMAGE_SIZE+1,Speelveld[NbrTile.kollom][NbrTile.rij].rij*IMAGE_SIZE+1, ColourAttack, FALSE);
	
		END;
		
		i:=1;
		WHILE (NbrTile.kollom+i<=NBR_COLUMNS) AND (Speelveld[NbrTile.kollom+i][NbrTile.rij].inhoud=NIL)
		AND (i<=NbrTile.inhoud^.movesThisTurn) AND (Speelveld[NbrTile.kollom+i][NbrTile.rij].soort^.toegankelijk) DO
			Rectangle((Speelveld[NbrTile.kollom+i][NbrTile.rij].kollom-1)*IMAGE_SIZE+1, (Speelveld[NbrTile.kollom][NbrTile.rij].rij-1)*IMAGE_SIZE+1,
				 Speelveld[NbrTile.kollom+i][NbrTile.rij].kollom*IMAGE_SIZE+1,Speelveld[NbrTile.kollom][NbrTile.rij].rij*IMAGE_SIZE+1, Colour, FALSE);
			INC(i);
		END;
		IF (NbrTile.kollom+i<=NBR_COLUMNS) AND (Speelveld[NbrTile.kollom+i][NbrTile.rij].inhoud#NIL) AND (Speelveld[NbrTile.kollom+i][NbrTile.rij].inhoud^.side#Player) THEN
			Rectangle((Speelveld[NbrTile.kollom+i][NbrTile.rij].kollom-1)*IMAGE_SIZE+1, (Speelveld[NbrTile.kollom][NbrTile.rij].rij-1)*IMAGE_SIZE+1,
				 Speelveld[NbrTile.kollom+i][NbrTile.rij].kollom*IMAGE_SIZE+1,Speelveld[NbrTile.kollom][NbrTile.rij].rij*IMAGE_SIZE+1, ColourAttack, FALSE);
	
		END;
		
		i:=1;
		WHILE (NbrTile.rij>i) AND (Speelveld[NbrTile.kollom][NbrTile.rij-i].inhoud=NIL)
		AND (i<=NbrTile.inhoud^.movesThisTurn) AND (Speelveld[NbrTile.kollom][NbrTile.rij-i].soort^.toegankelijk) DO
			Rectangle((Speelveld[NbrTile.kollom][NbrTile.rij].kollom-1)*IMAGE_SIZE+1, (Speelveld[NbrTile.kollom][NbrTile.rij-i].rij-1)*IMAGE_SIZE+1,
				 Speelveld[NbrTile.kollom][NbrTile.rij].kollom*IMAGE_SIZE+1,Speelveld[NbrTile.kollom][NbrTile.rij-i].rij*IMAGE_SIZE+1, Colour, FALSE);
			INC(i);
		END;
		IF (NbrTile.rij>i) AND (Speelveld[NbrTile.kollom][NbrTile.rij-i].inhoud#NIL) AND (Speelveld[NbrTile.kollom][NbrTile.rij-i].inhoud^.side#Player) THEN
			Rectangle((Speelveld[NbrTile.kollom][NbrTile.rij].kollom-1)*IMAGE_SIZE+1, (Speelveld[NbrTile.kollom][NbrTile.rij-i].rij-1)*IMAGE_SIZE+1,
				 Speelveld[NbrTile.kollom][NbrTile.rij].kollom*IMAGE_SIZE+1,Speelveld[NbrTile.kollom][NbrTile.rij-i].rij*IMAGE_SIZE+1, ColourAttack, FALSE);
	
		END;
		
		i:=1;
		WHILE (NbrTile.rij+i<=NBR_ROWS) AND (Speelveld[NbrTile.kollom][NbrTile.rij+i].inhoud=NIL)
		AND (i<=NbrTile.inhoud^.movesThisTurn) AND (Speelveld[NbrTile.kollom][NbrTile.rij+i].soort^.toegankelijk) DO
			Rectangle((Speelveld[NbrTile.kollom][NbrTile.rij].kollom-1)*IMAGE_SIZE+1, (Speelveld[NbrTile.kollom][NbrTile.rij+i].rij-1)*IMAGE_SIZE+1,
				 Speelveld[NbrTile.kollom][NbrTile.rij].kollom*IMAGE_SIZE+1,Speelveld[NbrTile.kollom][NbrTile.rij+i].rij*IMAGE_SIZE+1, Colour, FALSE);
			INC(i);
		END;
		IF (NbrTile.rij+i<=NBR_ROWS) AND (Speelveld[NbrTile.kollom][NbrTile.rij+i].inhoud#NIL) AND (Speelveld[NbrTile.kollom][NbrTile.rij+i].inhoud^.side#Player) THEN
			Rectangle((Speelveld[NbrTile.kollom][NbrTile.rij].kollom-1)*IMAGE_SIZE+1, (Speelveld[NbrTile.kollom][NbrTile.rij+i].rij-1)*IMAGE_SIZE+1,
				 Speelveld[NbrTile.kollom][NbrTile.rij].kollom*IMAGE_SIZE+1,Speelveld[NbrTile.kollom][NbrTile.rij+i].rij*IMAGE_SIZE+1, ColourAttack, FALSE);
		END;
	END TekenMoveOptions;
	
	
	

    PROCEDURE TekenShootTile(Tile : SpeelveldTileRc; Side1, Side2, nbrTiles: INTEGER; Colour : CARDINAL);             (*dit is en recursieve procedure die nakijkt*)
    	BEGIN                                                                                                         (*  op welke tiles er kan geschoten worden  *)
    	IF (Tile.soort^.beschietbaar) AND (nbrTiles>=0) THEN
		Rectangle( (Tile.kollom-1)*IMAGE_SIZE+1, (Tile.rij-1)*IMAGE_SIZE+1, Tile.kollom*IMAGE_SIZE+1, Tile.rij*IMAGE_SIZE+1, Colour, FALSE);
		IF (Side2>0) AND (Tile.kollom<NBR_COLUMNS) AND ( (Side2<=ABS(Side1)) OR (Side1=0) ) THEN
			IF ( ( (Side1>2) AND (NOT Speelveld[Tile.kollom][Tile.rij-1].soort^.beschietbaar) )
			OR ( (Side1<-2) AND (NOT Speelveld[Tile.kollom][Tile.rij+1].soort^.beschietbaar) ) ) AND (Side2>1) THEN
				Rectangle( (Tile.kollom-1)*IMAGE_SIZE+1, (Tile.rij-1)*IMAGE_SIZE+1, Tile.kollom*IMAGE_SIZE+1, Tile.rij*IMAGE_SIZE+1, _clrBLACK, FALSE);			
			END;                                                                                                 (* Side1 is de verticale richting ==> + naar boven  *)
			IF (NOT ((Side1>0) AND (NOT Speelveld[Tile.kollom][Tile.rij-1].soort^.beschietbaar)))                (*                                ==> - naar beneden*)
			AND  (NOT ((Side1<0) AND (NOT Speelveld[Tile.kollom][Tile.rij+1].soort^.beschietbaar)) ) THEN        (*                                ==> 0 is midden*)
				TekenShootTile(Speelveld[Tile.kollom+1][Tile.rij],2*Side1,Side2,nbrTiles-1, Colour);         (* Side 2 is de horizontale richting ==> + naar rechts *)
			END;                                                                                                 (*                                   ==> - naar links *)
		ELSIF (Side2<0) AND (Tile.kollom>1) AND ( (ABS(Side2)<=ABS(Side1)) OR (Side1=0) ) THEN                       (*                                   ==> 0 is midden*)
			IF ( ( (Side1>2) AND (NOT Speelveld[Tile.kollom][Tile.rij-1].soort^.beschietbaar) )
			OR ( (Side1<-2) AND (NOT Speelveld[Tile.kollom][Tile.rij+1].soort^.beschietbaar) ) ) AND (Side2<-1) THEN
				Rectangle( (Tile.kollom-1)*IMAGE_SIZE+1, (Tile.rij-1)*IMAGE_SIZE+1, Tile.kollom*IMAGE_SIZE+1, Tile.rij*IMAGE_SIZE+1, _clrBLACK, FALSE);
			END;
			IF (NOT ((Side1>0) AND (NOT Speelveld[Tile.kollom][Tile.rij-1].soort^.beschietbaar)))
			AND  (NOT ((Side1<0) AND (NOT Speelveld[Tile.kollom][Tile.rij+1].soort^.beschietbaar)) ) THEN
                         	TekenShootTile(Speelveld[Tile.kollom-1][Tile.rij],2*Side1,Side2, nbrTiles-1,Colour);
			END;
		END;
		IF (Side1>0) AND (Tile.rij<NBR_ROWS) AND ( (Side1<=ABS(Side2)) OR (Side2=0) ) THEN
			IF ( ( (Side2>2) AND (NOT Speelveld[Tile.kollom-1][Tile.rij].soort^.beschietbaar) )
			OR ( (Side2<-2) AND (NOT Speelveld[Tile.kollom+1][Tile.rij].soort^.beschietbaar) ) ) AND (Side1>1) THEN
				Rectangle( (Tile.kollom-1)*IMAGE_SIZE+1, (Tile.rij-1)*IMAGE_SIZE+1, Tile.kollom*IMAGE_SIZE+1, Tile.rij*IMAGE_SIZE+1, _clrBLACK, FALSE);
                        END;
			IF (NOT ((Side2>0) AND (NOT Speelveld[Tile.kollom-1][Tile.rij].soort^.beschietbaar)))
			AND (NOT ((Side2<0) AND (NOT Speelveld[Tile.kollom+1][Tile.rij].soort^.beschietbaar)) ) THEN
                                TekenShootTile(Speelveld[Tile.kollom][Tile.rij+1],Side1,2*Side2, nbrTiles-1,Colour);
			END;
			IF (Side2=Side1) AND (Tile.kollom<NBR_COLUMNS) THEN
				TekenShootTile(Speelveld[Tile.kollom+1][Tile.rij+1],Side1*2,Side2*2,nbrTiles-2,Colour);
			ELSIF (Side2=-Side1) AND (Tile.kollom>1) THEN
				TekenShootTile(Speelveld[Tile.kollom-1][Tile.rij+1],Side1*2,Side2*2,nbrTiles-2,Colour);
			END;			
		ELSIF  (Side1<0) AND (Tile.rij>1) AND ( (ABS(Side1)<=ABS(Side2)) OR (Side2=0) ) THEN
			IF ( ( (Side2>2) AND (NOT Speelveld[Tile.kollom-1][Tile.rij].soort^.beschietbaar) )
			OR ( (Side2<-2) AND (NOT Speelveld[Tile.kollom+1][Tile.rij].soort^.beschietbaar) ) ) AND (Side1<-1) THEN
				Rectangle( (Tile.kollom-1)*IMAGE_SIZE+1, (Tile.rij-1)*IMAGE_SIZE+1, Tile.kollom*IMAGE_SIZE+1, Tile.rij*IMAGE_SIZE+1, _clrBLACK, FALSE);
                        END;
			IF (NOT ((Side2>0) AND (NOT Speelveld[Tile.kollom-1][Tile.rij].soort^.beschietbaar)))
			AND (NOT ((Side2<0) AND (NOT Speelveld[Tile.kollom+1][Tile.rij].soort^.beschietbaar)) ) THEN
                                TekenShootTile(Speelveld[Tile.kollom][Tile.rij-1],Side1,2*Side2, nbrTiles-1,Colour);
			END;
			IF (Side2=-Side1) AND (Tile.kollom<NBR_COLUMNS) THEN
				TekenShootTile(Speelveld[Tile.kollom+1][Tile.rij-1],Side1*2,Side2*2,nbrTiles-2,Colour);
			ELSIF (Side2=Side1) AND (Tile.kollom>1) THEN
				TekenShootTile(Speelveld[Tile.kollom-1][Tile.rij-1],Side1*2,Side2*2,nbrTiles-2,Colour);
			END;
		END;
		
	END;
    	END TekenShootTile;
	
	
		
    PROCEDURE TekenShootOptions(Tile : SpeelveldTileRc; Colour : CARDINAL);     (* deze procedure tekent alle schietopties *)
	BEGIN                                                                   (* en maakt gebruik van de TekenShootTile-procedure*)
	     	IF (Tile.rij>2) AND (Speelveld[Tile.kollom][Tile.rij-1].soort^.beschietbaar) THEN             (* de IF's kijken na ofdat er niet *)
		TekenShootTile(Speelveld[Tile.kollom][Tile.rij-2],-1,0,Tile.inhoud^.range-2,Colour);          (* buiten het scherm gegaan wordt  *)
		END;                                                                                          (* en ofdat het maximaal aantal    *)
		IF (Tile.rij<NBR_ROWS-1) AND (Speelveld[Tile.kollom][Tile.rij+1].soort^.beschietbaar) THEN    (* Tiles niet overschreden wordt   *)
		TekenShootTile(Speelveld[Tile.kollom][Tile.rij+2],1,0,Tile.inhoud^.range-2,Colour);
		END;
		IF (Tile.kollom>2) AND (Speelveld[Tile.kollom-1][Tile.rij].soort^.beschietbaar) THEN
		TekenShootTile(Speelveld[Tile.kollom-2][Tile.rij],0,-1,Tile.inhoud^.range-2,Colour);
		END;
		IF (Tile.kollom<NBR_COLUMNS-1) AND (Speelveld[Tile.kollom+1][Tile.rij].soort^.beschietbaar) THEN
		TekenShootTile(Speelveld[Tile.kollom+2][Tile.rij],0,1,Tile.inhoud^.range-2,Colour);
		END;
		IF (Tile.rij<NBR_ROWS) AND (Tile.kollom<NBR_COLUMNS) THEN
                TekenShootTile(Speelveld[Tile.kollom+1][Tile.rij+1],1,1,Tile.inhoud^.range-2,Colour);
		END;
		IF (Tile.rij<NBR_ROWS) AND (Tile.kollom>1) THEN
		TekenShootTile(Speelveld[Tile.kollom-1][Tile.rij+1],1,-1,Tile.inhoud^.range-2,Colour);
		END;
		IF (Tile.rij>1) AND (Tile.kollom>1) THEN
		TekenShootTile(Speelveld[Tile.kollom-1][Tile.rij-1],-1,-1,Tile.inhoud^.range-2,Colour);
		END;
		IF (Tile.rij>1) AND (Tile.kollom<NBR_COLUMNS) THEN
 		TekenShootTile(Speelveld[Tile.kollom+1][Tile.rij-1],-1,1,Tile.inhoud^.range-2,Colour);
                END;
	     IF   Tile.inhoud^.range>=5 THEN
	     	IF Tile.rij>2 THEN
                Rectangle( (Tile.kollom-1)*IMAGE_SIZE+1, (Tile.rij-3)*IMAGE_SIZE+1, Tile.kollom*IMAGE_SIZE+1, (Tile.rij-2)*IMAGE_SIZE+1, _clrBLACK, FALSE);
		END;
		IF Tile.rij<NBR_ROWS-1 THEN
		Rectangle( (Tile.kollom-1)*IMAGE_SIZE+1, (Tile.rij+1)*IMAGE_SIZE+1, Tile.kollom*IMAGE_SIZE+1, (Tile.rij+2)*IMAGE_SIZE+1, _clrBLACK, FALSE);
		END;
		IF Tile.kollom>2 THEN
		Rectangle( (Tile.kollom-3)*IMAGE_SIZE+1, (Tile.rij-1)*IMAGE_SIZE+1, (Tile.kollom-2)*IMAGE_SIZE+1, Tile.rij*IMAGE_SIZE+1, _clrBLACK, FALSE);
		END;
		IF Tile.kollom<NBR_COLUMNS-1 THEN
		Rectangle( (Tile.kollom+1)*IMAGE_SIZE+1, (Tile.rij-1)*IMAGE_SIZE+1, (Tile.kollom+2)*IMAGE_SIZE+1, Tile.rij*IMAGE_SIZE+1, _clrBLACK, FALSE);
		END;
		IF (Tile.rij<NBR_ROWS) AND (Tile.kollom<NBR_COLUMNS) THEN
		Rectangle( Tile.kollom*IMAGE_SIZE+1, Tile.rij*IMAGE_SIZE+1, (Tile.kollom+1)*IMAGE_SIZE+1, (Tile.rij+1)*IMAGE_SIZE+1, _clrBLACK, FALSE);
		END;
		IF (Tile.rij<NBR_ROWS) AND (Tile.kollom>1) THEN
		Rectangle( (Tile.kollom-2)*IMAGE_SIZE+1, Tile.rij*IMAGE_SIZE+1, (Tile.kollom-1)*IMAGE_SIZE+1, (Tile.rij+1)*IMAGE_SIZE+1, _clrBLACK, FALSE);
		END;
		IF (Tile.rij>1) AND (Tile.kollom>1) THEN
		Rectangle( (Tile.kollom-2)*IMAGE_SIZE+1, (Tile.rij-2)*IMAGE_SIZE+1, (Tile.kollom-1)*IMAGE_SIZE+1, (Tile.rij-1)*IMAGE_SIZE+1, _clrBLACK, FALSE);
		END;
		IF (Tile.rij>1) AND (Tile.kollom<NBR_COLUMNS) THEN
		Rectangle( Tile.kollom*IMAGE_SIZE+1, (Tile.rij-2)*IMAGE_SIZE+1, (Tile.kollom+1)*IMAGE_SIZE+1, (Tile.rij-1)*IMAGE_SIZE+1, _clrBLACK, FALSE);
                END;
	     END;
	
		END TekenShootOptions;
		
		
(*		INGAME-TEKST PROCEDURES		*)		
(************************************************)	
    PROCEDURE VoegDamageAanTekst(Getal : CARDINAL): Tekst;    (* een kleine procedure om een *)
    	VAR   DamageTekst	: 	Tekst;                (* damage-rapport te schrijven *)
	BEGIN
		CardToStr(Getal, DamageTekst);
		Insert(DamageTekst, 'For ', 0);
		StrConcatenate(DamageTekst, " Damage");
	RETURN DamageTekst;
	END VoegDamageAanTekst;
	
	
    PROCEDURE TekenTekst();                                    (* procedure die de tekst tekent*)
    	VAR i		: CARDINAL;
    	BEGIN
		Rectangle ( SCREEN_WIDTH-MENU_SIZE+5, 97, SCREEN_WIDTH-5, 195, _clrBLACK, TRUE);
		FOR i:=1 TO 6 DO
			IF TekstVak[i].speler=1 THEN
			RawOutText(SCREEN_WIDTH-MENU_SIZE+5,193-(i*16),_clrBROWN,TekstVak[i].tekst);
			ELSE RawOutText(SCREEN_WIDTH-MENU_SIZE+5,193-(i*16),_clrLIGHTMAGENTA,TekstVak[i].tekst);
			END;
		END;
	END TekenTekst;

    PROCEDURE VoegTekstToe1(NieuweTekst : ARRAY OF CHAR);       (* procedure om nieuwe tekst toe te voegen *)
    	BEGIN                                                   (* die te maken heeft met de actieve player*)
		TekstVak[6]:=TekstVak[5];
		TekstVak[5]:=TekstVak[4];
		TekstVak[4]:=TekstVak[3];
		TekstVak[3]:=TekstVak[2];
		TekstVak[2]:=TekstVak[1];
		StrCopy(TekstVak[1].tekst,NieuweTekst);
		TekstVak[1].speler:=Player;
                TekenTekst();
	END VoegTekstToe1;
	
	
	
    PROCEDURE VoegTekstToe2(NieuweTekst : ARRAY OF CHAR);        (* procedure om nieuwe tekst toe te voegen *)
    	BEGIN                                                    (* die te maken heeft met de niet-actieve player*)
		TekstVak[6]:=TekstVak[5];
		TekstVak[5]:=TekstVak[4];
		TekstVak[4]:=TekstVak[3];
		TekstVak[3]:=TekstVak[2];
		TekstVak[2]:=TekstVak[1];
		StrCopy(TekstVak[1].tekst,NieuweTekst);
		IF Player= 1 THEN
		TekstVak[1].speler:=2;
		ELSE TekstVak[1].speler:=1;
		END;
                TekenTekst;
	END VoegTekstToe2;

    PROCEDURE ClearTekst();
    VAR i		:		CARDINAL;
    BEGIN 	FOR i:=1 TO 6 DO
    			TekstVak[i].tekst:='';
		END;
    END ClearTekst;
	
		
(*		UNIT-PROCEDURES		*)	
(****************************************)
    PROCEDURE PlaySound(Sound1, Sound2: SoundEventEn);
        BEGIN
		IF RandomCard(1,2)=1 THEN
			PlaySoundEvent(Sound1);
		ELSE
			PlaySoundEvent(Sound2);
		END;
	END PlaySound;
    	
    PROCEDURE SelectUnit(Tile : SpeelveldTileRc);                        (* de info van de geselecteerde unit wordt getekend *)
    	BEGIN
		Rectangle(SCREEN_WIDTH-52, 330, SCREEN_WIDTH-20, 555, _clrBLACK, TRUE);
		Rectangle (SCREEN_WIDTH-MENU_SIZE+20, 305, SCREEN_WIDTH-20, 330, _clrBLACK, TRUE);
		IF Tile.inhoud#NIL THEN
			DrawNumber(SCREEN_WIDTH-35,  342, Tile.inhoud^.men, _clrLIGHTCYAN, _clrBLACK);
			DrawNumber(SCREEN_WIDTH-35,  368, Tile.inhoud^.health, _clrLIGHTCYAN, _clrBLACK);
			DrawNumber(SCREEN_WIDTH-35,  394, Tile.inhoud^.attack*Tile.inhoud^.men, _clrLIGHTCYAN, _clrBLACK);
                        DrawNumber(SCREEN_WIDTH-35,  420, Tile.inhoud^.range, _clrLIGHTCYAN, _clrBLACK);
			DrawNumber(SCREEN_WIDTH-35,  446, Tile.inhoud^.rangedAttack*Tile.inhoud^.men, _clrLIGHTCYAN, _clrBLACK);
			DrawNumber(SCREEN_WIDTH-35,  472, Tile.inhoud^.ammo, _clrLIGHTCYAN, _clrBLACK);
			DrawNumber(SCREEN_WIDTH-35,  498, Tile.inhoud^.movesThisTurn, _clrLIGHTCYAN, _clrBLACK);
			IF Tile.inhoud^.side=Player THEN
				TekenSelectUnit(Tile, _clrLIGHTYELLOW);
				RawOutText(SCREEN_WIDTH-MENU_SIZE+60, 306, _clrLIGHTYELLOW, Tile.inhoud^.name);
			ELSE	TekenSelectUnit(Tile, _clrLIGHTMAGENTA);
				RawOutText(SCREEN_WIDTH-MENU_SIZE+60, 306, _clrLIGHTMAGENTA, Tile.inhoud^.name);
			END;

		END;
	END SelectUnit;
	
	
	
    PROCEDURE CheckHealth(VAR Tile : SpeelveldTileRc);      (* procedure om de paramater 'men'*)
    	BEGIN                                               (*    van een unit te geupdaten   *)
		Tile.inhoud^.men:=VAL(CARDINAL, (Tile.inhoud^.health/Tile.inhoud^.healthPerUnit));
		IF Tile.inhoud^.men*Tile.inhoud^.healthPerUnit<Tile.inhoud^.health THEN
			Tile.inhoud^.men:=Tile.inhoud^.men+1;
		END;
	END CheckHealth;
	
		
	
    PROCEDURE MoveUnit(VAR FromTile, ToTile : SpeelveldTileRc);   (* procedure om een unit te verplaatsen *)
	BEGIN
		TekenMoveOptions(FromTile, _clrBLACK,_clrBLACK);
		IF (FromTile.kollom#ToTile.kollom) OR (FromTile.rij#ToTile.rij)THEN
			TekenUnit(FromTile.inhoud^,ToTile);
			TekenTile(FromTile);
			DISPOSE(Speelveld[FromTile.kollom][FromTile.rij].inhoud);
		END;
		IF ToTile.inhoud^.movesThisTurn>VAL(CARDINAL,ABS(VAL(INTEGER,FromTile.kollom)-
			VAL(INTEGER,ToTile.kollom)+VAL(INTEGER,FromTile.rij)-VAL(INTEGER,ToTile.rij))) THEN
		ToTile.inhoud^.movesThisTurn:= ToTile.inhoud^.movesThisTurn-VAL(CARDINAL,ABS(VAL(INTEGER,FromTile.kollom)-
			VAL(INTEGER,ToTile.kollom)+VAL(INTEGER,FromTile.rij)-VAL(INTEGER,ToTile.rij)));
		ELSE ToTile.inhoud^.movesThisTurn:=0;
		END;
	END MoveUnit;
	
	

    PROCEDURE DeathUnit(VAR Tile: SpeelveldTileRc);    (* procedure om een unit te laten sterven *)
    	BEGIN
		StrCopy(NieuweTekst, Tile.inhoud^.name);
		StrConcatenate(NieuweTekst, ' Dies');
		IF Tile.inhoud^.side=Player THEN
		VoegTekstToe1(NieuweTekst);
		ELSE VoegTekstToe2(NieuweTekst);
		END;
		
		PlaySound(DEATH1, DEATH2);
		(*IF RandomCard(1,2)=1 THEN
			PlaySoundEvent(DEATH1);
		ELSE
			PlaySoundEvent(DEATH2);
		END; *)
		DISPOSE(Tile.inhoud);
		TekenTile(Tile);
	END DeathUnit;
	
	
	
    PROCEDURE AttackUnit(VAR FromTile, ToTile : SpeelveldTileRc);    (* procedure om een unit te laten aanvallen*)
    	BEGIN
		TekenMoveOptions(FromTile, _clrBLACK,_clrBLACK);
		IF FromTile.inhoud^.movesThisTurn#0 THEN
			StrCopy(NieuweTekst,FromTile.inhoud^.name);
			StrConcatenate(NieuweTekst, ' Attacks ');
			StrConcatenate(NieuweTekst,ToTile.inhoud^.name);
			VoegTekstToe1(NieuweTekst);
			PlaySound(ATTACK1, ATTACK2);
			(*IF RandomCard(1,2)=1 THEN
				PlaySoundEvent(ATTACK1);
			ELSE
				PlaySoundEvent(ATTACK2);
			END;  *)
			VoegTekstToe1(VoegDamageAanTekst(FromTile.inhoud^.attack*FromTile.inhoud^.men));
			
			StrCopy(NieuweTekst,ToTile.inhoud^.name);
			StrConcatenate(NieuweTekst, ' Defends ');
			VoegTekstToe2(NieuweTekst);
			VoegTekstToe2(VoegDamageAanTekst(ToTile.inhoud^.attack*ToTile.inhoud^.men));

			IF FromTile.inhoud^.movesThisTurn>3 THEN
				FromTile.inhoud^.movesThisTurn:=FromTile.inhoud^.movesThisTurn-3;
			ELSE FromTile.inhoud^.movesThisTurn:=0;
			END;
			IF ToTile.inhoud^.health>FromTile.inhoud^.attack*FromTile.inhoud^.men THEN
				ToTile.inhoud^.health:=ToTile.inhoud^.health-FromTile.inhoud^.attack*FromTile.inhoud^.men;
				IF FromTile.inhoud^.health>ToTile.inhoud^.attack*ToTile.inhoud^.men THEN
					FromTile.inhoud^.health:=FromTile.inhoud^.health-ToTile.inhoud^.attack*ToTile.inhoud^.men;
					CheckHealth(ToTile); CheckHealth(FromTile);
					IF FromTile.kollom=ToTile.kollom THEN
						IF FromTile.rij>ToTile.rij THEN
						MoveUnit(FromTile,Speelveld[ToTile.kollom][ToTile.rij+1]);
						FromTile:=Speelveld[ToTile.kollom][ToTile.rij+1]
						ELSE
						MoveUnit(FromTile,Speelveld[ToTile.kollom][ToTile.rij-1]);
						FromTile:=Speelveld[ToTile.kollom][ToTile.rij-1];
						END;
					ELSE
						IF FromTile.kollom>ToTile.kollom  THEN
						MoveUnit(FromTile,Speelveld[ToTile.kollom+1][ToTile.rij]);
						FromTile:=Speelveld[ToTile.kollom+1][ToTile.rij];
						ELSE
						MoveUnit(FromTile,Speelveld[ToTile.kollom-1][ToTile.rij]);
						FromTile:=Speelveld[ToTile.kollom-1][ToTile.rij];	
						END;
					END;
				ELSE    CheckHealth(ToTile);
					DeathUnit(Speelveld[FromTile.kollom][FromTile.rij]);
					FromTile.inhoud:=NIL;
				END;
				
			ELSE
				IF FromTile.inhoud^.health>ToTile.inhoud^.attack*ToTile.inhoud^.men THEN
					FromTile.inhoud^.health:=FromTile.inhoud^.health-ToTile.inhoud^.attack*ToTile.inhoud^.men;
					CheckHealth(FromTile);
				ELSE    FromTile.inhoud^.health:=1;
					CheckHealth(FromTile);

				END;
				IF FromTile.kollom=ToTile.kollom THEN
					IF FromTile.rij>ToTile.rij THEN
					MoveUnit(FromTile,Speelveld[ToTile.kollom][ToTile.rij+1]);
					FromTile:=Speelveld[ToTile.kollom][ToTile.rij+1];
					ELSE
					MoveUnit(FromTile,Speelveld[ToTile.kollom][ToTile.rij-1]);
					FromTile:=Speelveld[ToTile.kollom][ToTile.rij-1];
					END;
				ELSE
					IF FromTile.kollom>ToTile.kollom  THEN
					MoveUnit(FromTile,Speelveld[ToTile.kollom+1][ToTile.rij]);
					FromTile:=Speelveld[ToTile.kollom+1][ToTile.rij];
					ELSE
					MoveUnit(FromTile,Speelveld[ToTile.kollom-1][ToTile.rij]);
					FromTile:=Speelveld[ToTile.kollom-1][ToTile.rij];	
					END;
				END;
				DeathUnit(ToTile);
			END;
		END;
	END AttackUnit;
	
    PROCEDURE CheckGoodShoot(FromTile, ToTile : SpeelveldTileRc): BOOLEAN;	
    VAR i, j		:	CARDINAL;
    	geldigSchot	:	BOOLEAN;
    BEGIN
    	geldigSchot:=TRUE;
    	IF ToTile.kollom>FromTile.kollom THEN                                 (* er wordt nagegaan of het schot geldig is *)
	    IF (VAL(INTEGER,ToTile.kollom)-ABS( VAL(INTEGER,ToTile.rij)-VAL(INTEGER,FromTile.rij) ) >0)
	    AND ( ToTile.kollom-VAL(CARDINAL , ABS( VAL(INTEGER,ToTile.rij)-VAL(INTEGER,FromTile.rij) ) )>= FromTile.kollom ) THEN
	    	FOR i:= FromTile.kollom  TO ToTile.kollom-VAL(CARDINAL, ABS( VAL(INTEGER,ToTile.rij)-VAL(INTEGER,FromTile.rij) )) DO
		     IF (NOT Speelveld[i][FromTile.rij].soort^.beschietbaar) THEN
		     geldigSchot:=FALSE;
		     END;
	    	END;
	    END;
	    FOR i:=FromTile.kollom+1 TO ToTile.kollom DO
		IF ToTile.rij>FromTile.rij THEN
		     FOR j:=FromTile.rij+1 TO ToTile.rij DO
		     	IF (NOT Speelveld[i][j].soort^.beschietbaar) THEN
			geldigSchot:=FALSE;
			END;
		     END;
		     IF (VAL(INTEGER,ToTile.rij)-ABS( VAL(INTEGER,ToTile.kollom)-VAL(INTEGER,FromTile.kollom) ) >0)
	    	     AND ( ToTile.rij-VAL(CARDINAL , ABS( VAL(INTEGER,ToTile.kollom)-VAL(INTEGER,FromTile.kollom) ) )>= FromTile.rij ) THEN
                     	FOR j:= FromTile.rij  TO ToTile.rij-(ToTile.kollom-FromTile.kollom) DO
		             IF (NOT Speelveld[FromTile.kollom][j].soort^.beschietbaar) THEN
			     geldigSchot:=FALSE;
			     END;
		     	END;
		     END;
		ELSIF ToTile.rij<FromTile.rij THEN
		     FOR j:=FromTile.rij-1 TO ToTile.rij BY -1 DO
		     	IF (NOT Speelveld[i][j].soort^.beschietbaar) THEN
			geldigSchot:=FALSE;
			END;
		     END;
		     IF ToTile.rij+VAL( CARDINAL,ABS( VAL(INTEGER,ToTile.kollom)-VAL(INTEGER,FromTile.kollom) ) )<=NBR_ROWS THEN
		     	FOR j:= FromTile.rij  TO ToTile.rij+(ToTile.kollom-FromTile.kollom) BY -1 DO
		             IF (NOT Speelveld[FromTile.kollom][j].soort^.beschietbaar) THEN
			     geldigSchot:=FALSE;
			     END;
		     	END;
		     END;
		END;
	     END;
	ELSIF ToTile.kollom<FromTile.kollom THEN
	     IF ToTile.kollom+VAL( CARDINAL,ABS( VAL(INTEGER,ToTile.rij)-VAL(INTEGER,FromTile.rij) ) )<=NBR_COLUMNS THEN
             	FOR i:= FromTile.kollom  TO ToTile.kollom+VAL(CARDINAL, ABS( VAL(INTEGER,FromTile.rij)-VAL(INTEGER,ToTile.rij) )) BY -1 DO
		     IF (NOT Speelveld[i][FromTile.rij].soort^.beschietbaar) THEN
		     geldigSchot:=FALSE;
		     END;
	     	END;
	     END;
	     FOR i:=FromTile.kollom-1 TO ToTile.kollom BY -1 DO
		IF ToTile.rij>FromTile.rij THEN
		     FOR j:=FromTile.rij+1 TO ToTile.rij DO
		     	IF (NOT Speelveld[i][j].soort^.beschietbaar) THEN
			geldigSchot:=FALSE;
			END;
		     END;
		     IF (VAL(INTEGER,ToTile.rij)-ABS( VAL(INTEGER,ToTile.kollom)-VAL(INTEGER,FromTile.kollom) ) >0)
	    	     AND ( ToTile.rij-VAL(CARDINAL , ABS( VAL(INTEGER,ToTile.kollom)-VAL(INTEGER,FromTile.kollom) ) )>= FromTile.rij ) THEN
			FOR j:= FromTile.rij  TO ToTile.rij-(FromTile.kollom-ToTile.kollom) DO
		             IF (NOT Speelveld[FromTile.kollom][j].soort^.beschietbaar) THEN
			     geldigSchot:=FALSE;
			     END;
		     	END;
		     END;
		ELSIF ToTile.rij<FromTile.rij THEN
		     FOR j:=FromTile.rij-1 TO ToTile.rij BY -1 DO
		     	IF (NOT Speelveld[i][j].soort^.beschietbaar) THEN
			geldigSchot:=FALSE;
			END;
		     END;
     		     IF ToTile.rij+VAL( CARDINAL,ABS( VAL(INTEGER,ToTile.kollom)-VAL(INTEGER,FromTile.kollom) ) )<=NBR_ROWS THEN
		     	FOR j:= FromTile.rij  TO ToTile.rij+(FromTile.kollom-ToTile.kollom) BY -1 DO
		             IF (NOT Speelveld[FromTile.kollom][j].soort^.beschietbaar) THEN
			     geldigSchot:=FALSE;
			     END;
		     	END;
		     END;
		END;
	     END;
	ELSE
		IF ToTile.rij>FromTile.rij THEN
		     FOR j:=FromTile.rij+1 TO ToTile.rij DO
		     	IF (NOT Speelveld[FromTile.kollom][j].soort^.beschietbaar) THEN
			geldigSchot:=FALSE;
			END;
		     END;
		ELSE
		     FOR j:=FromTile.rij-1 TO ToTile.rij BY -1 DO
		     	IF (NOT Speelveld[FromTile.kollom][j].soort^.beschietbaar) THEN
			geldigSchot:=FALSE;
			END;
		     END;
		END;
	END;
	
	IF ABS(VAL(INTEGER,FromTile.kollom) -VAL(INTEGER,ToTile.kollom) )=ABS(VAL(INTEGER,FromTile.rij) -VAL(INTEGER, ToTile.rij) ) THEN
	geldigSchot:=TRUE;
	FOR i:= 1 TO  VAL(CARDINAL, ABS( VAL(INTEGER,FromTile.kollom) -VAL(INTEGER,ToTile.kollom) )) DO
		IF (ToTile.kollom>FromTile.kollom) AND (ToTile.rij>FromTile.rij) THEN
			IF (NOT Speelveld[FromTile.kollom+i][FromTile.rij+i].soort^.beschietbaar) THEN
			geldigSchot:=FALSE;
			END;
		ELSIF (ToTile.kollom>FromTile.kollom) AND (ToTile.rij<FromTile.rij) THEN
			IF NOT Speelveld[FromTile.kollom+i][FromTile.rij-i].soort^.beschietbaar THEN
			geldigSchot:=FALSE;
			END;
		ELSIF (ToTile.kollom<FromTile.kollom) AND (ToTile.rij>FromTile.rij) THEN
			IF NOT Speelveld[FromTile.kollom-i][FromTile.rij+i].soort^.beschietbaar THEN
			geldigSchot:=FALSE;
			END;
		ELSE
			IF NOT Speelveld[FromTile.kollom-i][FromTile.rij-i].soort^.beschietbaar THEN
			geldigSchot:=FALSE;
			END;
		END;
	END;
	END;
	RETURN geldigSchot;
    END CheckGoodShoot;

	
	
    PROCEDURE ShootUnit(FromTile : SpeelveldTileRc; VAR ToTile :SpeelveldTileRc)(*: BOOLEAN*);   (* procedure om een unit te laten schieten *)
    BEGIN
    	PlaySound(EXPLOSION1, EXPLOSION2);
	(*IF RandomCard(1,2)=1 THEN
		PlaySoundEvent(EXPLOSION1);
	ELSE
		PlaySoundEvent(EXPLOSION2);
	END; *)
	
	TekenDust(ToTile);
	Delay(DELAY_TIME);
	IF ToTile.inhoud#NIL THEN
		DrawSavedBitmap((ToTile.kollom-1) *IMAGE_SIZE+1, (ToTile.rij-1) *IMAGE_SIZE+2, ToTile.inhoud^.id);
	ELSE
		TekenTile(ToTile);
	END;
	IF (ToTile.inhoud#NIL) AND (ToTile.inhoud^.health>FromTile.inhoud^.rangedAttack*FromTile.inhoud^.men)THEN
		StrConcatenate(NieuweTekst, ToTile.inhoud^.name);
		IF ToTile.inhoud^.side=Player THEN
		VoegTekstToe1(NieuweTekst);
		ELSE VoegTekstToe2(NieuweTekst);
		END;
		VoegTekstToe1(VoegDamageAanTekst(FromTile.inhoud^.rangedAttack*FromTile.inhoud^.men));
                ToTile.inhoud^.health:=ToTile.inhoud^.health-FromTile.inhoud^.rangedAttack*FromTile.inhoud^.men;
		CheckHealth(ToTile);
	ELSIF (ToTile.inhoud#NIL) THEN
		StrConcatenate(NieuweTekst, ToTile.inhoud^.name);
		IF ToTile.inhoud^.side=Player THEN
		VoegTekstToe1(NieuweTekst);
		ELSE VoegTekstToe2(NieuweTekst);
		END;
		VoegTekstToe1(VoegDamageAanTekst(FromTile.inhoud^.rangedAttack*FromTile.inhoud^.men));
		DeathUnit(ToTile);
	ELSE	StrConcatenate(NieuweTekst, 'Nothing');
		VoegTekstToe1(NieuweTekst);
        END;
	FromTile.inhoud^.ammo:=FromTile.inhoud^.ammo-1;
	
(*	END;
	RETURN geldigSchot;    *)
    END ShootUnit;


    PROCEDURE Shoot(FromTile,ToTile : SpeelveldTileRc):BOOLEAN;
    VAR rdmShoot1, rdmShoot2			:	CARDINAL;
        rdmShootToTile1, rdmShootToTile2	:	INTEGER;
	geldigSchot				:	BOOLEAN;
    BEGIN
    	geldigSchot:=CheckGoodShoot(FromTile,ToTile);
        IF geldigSchot THEN
		TekenShootOptions(FromTile, _clrBLACK);
		StrCopy(NieuweTekst,FromTile.inhoud^.name);
		StrConcatenate(NieuweTekst, ' Shoots');
		rdmShoot1:=RandomCard(1,10);
		rdmShoot2:=RandomCard(1,10);
		IF rdmShoot1*rdmShoot2=100 THEN
			StrConcatenate(NieuweTekst, ' But');
			VoegTekstToe1(NieuweTekst);
			StrCopy(NieuweTekst,'Makes a Fatal Mistake!');
			VoegTekstToe1(NieuweTekst);
			StrCopy(NieuweTekst,'Gets Injured: ');
			ShootUnit(FromTile,Speelveld[FromTile.kollom][FromTile.rij]);
		ELSIF rdmShoot1=rdmShoot2 THEN
			StrConcatenate(NieuweTekst, ', Misses');
			VoegTekstToe1(NieuweTekst);
			StrCopy(NieuweTekst,'And Hits ');
			IF ToTile.kollom=1 THEN
			rdmShootToTile1:=VAL(INTEGER,RandomCard(1,2))-1;		
			ELSIF ToTile.kollom=NBR_COLUMNS THEN
			rdmShootToTile1:=VAL(INTEGER,RandomCard(0,1))-1;
			ELSE    rdmShootToTile1:=VAL(INTEGER,RandomCard(0,2))-1;
			END;
			IF ToTile.rij=1 THEN
			rdmShootToTile2:=VAL(INTEGER,RandomCard(1,2))-1;		
			ELSIF ToTile.rij=NBR_ROWS THEN
			rdmShootToTile2:=VAL(INTEGER,RandomCard(0,1))-1;
			ELSE    rdmShootToTile2:=VAL(INTEGER,RandomCard(0,2))-1;
			END;
			ShootUnit(FromTile,Speelveld[VAL(CARDINAL,VAL(INTEGER,ToTile.kollom)+rdmShootToTile1)][VAL(CARDINAL,VAL(INTEGER,ToTile.rij)+rdmShootToTile2)]);
	
		ELSE    VoegTekstToe1(NieuweTekst);
			StrCopy(NieuweTekst,'And Hits ');
			ShootUnit(FromTile,Speelveld[ToTile.kollom][ToTile.rij]);
		END;
	END;
     RETURN geldigSchot;
     END Shoot;	

(*		DE BEGIN- EN EINDPROCEDURES		*)
(********************************************************)	
     PROCEDURE InitUnits();
     VAR 	i		:		CARDINAL;
     BEGIN

	FOR i:=1 TO NBR_PLAYERS DO
		(*PlayerUnitsAr[i][pea].range:=0;
		PlayerUnitsAr[i][cav].range:=0; *)
		PlayerUnitsAr[i][inf].range:=2;
		PlayerUnitsAr[i][art].range:=6;

		PlayerUnitsAr[i][pea].attack:=4;
		PlayerUnitsAr[i][cav].attack:=8;
		PlayerUnitsAr[i][inf].attack:=6;
		PlayerUnitsAr[i][art].attack:=2;

		(*PlayerUnitsAr[i][pea].rangedAttack:=0;
		PlayerUnitsAr[i][cav].rangedAttack:=0; *)
		PlayerUnitsAr[i][inf].rangedAttack:=7;
		PlayerUnitsAr[i][art].rangedAttack:=10;

                PlayerUnitsAr[i][inf].ammo:=2;
		PlayerUnitsAr[i][art].ammo:=1;
		
		PlayerUnitsAr[i][cav].hitPoints:=20;
		PlayerUnitsAr[i][inf].hitPoints:=18;
		PlayerUnitsAr[i][art].hitPoints:=15;
		PlayerUnitsAr[i][pea].hitPoints:=16;

		PlayerUnitsAr[i][cav].endurance:=6;
		PlayerUnitsAr[i][inf].endurance:=4;
		PlayerUnitsAr[i][art].endurance:=1;
		PlayerUnitsAr[i][pea].endurance:=3;
	END;
     END InitUnits;


     PROCEDURE InitBattleScreen();        (* deze procedure initialiseert het BS *)
        VAR i, j, rdmPlaceRvr1, rdmPlaceRvr2, rdmPlaceRvr3, rdmTurnRvr1, rdmTurnRvr2,
	rdmBrug1, rdmBrug2, nbrRocks, rdmRock1, rdmRock2, rdmMaxNbrRocks	:			CARDINAL;
	    GrasBeeld, BridgeBeeld, RivierBeeld		:		ARRAY [1..IMAGE_SIZE],[1..IMAGE_SIZE] OF CHAR;
    	BEGIN
	gColorMap['b'] := _clrBLACK         ; (*    0*)
	gColorMap['c'] := _clrGREEN         ; (*    2*)
	gColorMap['d'] := _clrCYAN          ; (*    3*)
	gColorMap['e'] := _clrRED           ; (*    4*)
	gColorMap['k'] := _clrLIGHTYELLOW   ;(*    14*)

	GrasBeeld[1]:="bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb";       (* dit is de gras-Tile*)
	GrasBeeld[2]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[3]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[4]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[5]:="bcccccccccccckkkcccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[6]:="bcccccccccccckkkccccccccccccccccccccccccccccccccccccccccccccckkkcccccb";
	GrasBeeld[7]:="bcccccccccccckkkccccccccccccccccccccccccccccccccccccccccccccckkkcccccb";
	GrasBeeld[8]:="bcccccccccccckkkccccccccccccccccccccccccccccccccccccccccccccckkkcccccb";
	GrasBeeld[9]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[10]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[11]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[12]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[13]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[14]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[15]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[16]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[17]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[18]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[19]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[20]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[21]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[22]:="bccccccccccccccccccccccccccccccccccccccccccccccccccckkkccccccccccccccb";
	GrasBeeld[23]:="bccccccccccccccccccccccccccccccccccccccccccccccccccckkkccccccccccccccb";
	GrasBeeld[24]:="bccccccccccccccccccccccccccccccccccccccccccccccccccckkkccccccccccccccb";
	GrasBeeld[25]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[26]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[27]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[28]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[29]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[30]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[31]:="bccccccccccccccccccccccckkkccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[32]:="bccccccccccccccccccccccckkkccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[33]:="bccccccccccccccccccccccckkkccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[34]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[35]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[36]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[37]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[38]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[39]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[40]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[41]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[42]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[43]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[44]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[45]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[46]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[47]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[48]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[49]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[50]:="bccccccccccccccccccccccccccccccccccccccccckkkccccccccccccccccccccccccb";
	GrasBeeld[51]:="bccccccccccccccccccccccccccccccccccccccccckkkccccccccccccccccccccccccb";
	GrasBeeld[52]:="bccccccccccccccccccccccccccccccccccccccccckkkccccccccccccccccccccccccb";
	GrasBeeld[53]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[54]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[55]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[56]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[57]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[58]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[59]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[60]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[61]:="bccccccccccccccckkkccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[62]:="bccccccccccccccckkkccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[63]:="bccccccccccccccckkkccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[64]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[65]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[66]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[67]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[68]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[69]:="bccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccb";
	GrasBeeld[70]:="bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb";

	FOR i:=1 TO IMAGE_SIZE DO
		FOR j:= 1 TO IMAGE_SIZE DO
			RivierBeeld[i][j]:="b";
			BridgeBeeld[i][j]:="b";
		END;
	END;
	FOR i:=2 TO IMAGE_SIZE-1 DO
		BridgeBeeld[i]:="bddddddddbbddddddddbbddddddddbbddddddddbbddddddddbbddddddddbbddddddddb";  (* het "tekenen" van de brug-tile *)
		FOR j:= 2 TO IMAGE_SIZE-1 DO
			RivierBeeld[i][j]:="e";                                              (* het "tekenen" van het water-tile *)
		END;
	END;
	GrasRc.toegankelijk:=TRUE;
	BridgeRc.toegankelijk:=TRUE;
	RivierRc.toegankelijk:=FALSE;
	RockRc.toegankelijk:=FALSE;

	GrasRc.beschietbaar:=TRUE;
	BridgeRc.beschietbaar:=TRUE;
	RivierRc.beschietbaar:=TRUE;
	RockRc.beschietbaar:=FALSE;
	
	ClearScreen(0);
	IF GrasRc.id=0 THEN
        	FOR i := 1 TO IMAGE_SIZE DO                       		(* de grastile wordt voor  *)
	  		FOR j := 1 TO IMAGE_SIZE DO                             (* de eerste maal getekend *)
	    		Plot( j, i, gColorMap[GrasBeeld[i][j]]);
	    		END;
  		END;
		GetImage(1, 1, IMAGE_SIZE, IMAGE_SIZE, GrasRc.id);   		(* de grastile wordt gesaved *)
	END;
	
	IF RockRc.id=0 THEN
		RockRc.id := DrawBitmapFile(1, 2, "BSUnits/rots.bmp", i, j);    (* de rocktile wordt voor de eerste*)
		GetImage(1, 1, IMAGE_SIZE, IMAGE_SIZE, RockRc.id);              (*     maal getekend en gesaved    *)
 	END;

	IF RivierRc.id=0 THEN
        	FOR i := 1 TO IMAGE_SIZE DO                       		(* de riviertile wordt voor *)
	  		FOR j := 1 TO IMAGE_SIZE DO                             (* de eerste maal getekend  *)
	    		Plot( j, i, gColorMap[RivierBeeld[i][j]]);
	    		END;
  		END;
		GetImage(1, 1, IMAGE_SIZE, IMAGE_SIZE, RivierRc.id);            (* de riviertile wordt gesaved*)
	END;
	
	IF BridgeRc.id=0 THEN
		FOR i := 1 TO IMAGE_SIZE DO                       		(* de brugtile wordt voor  *)
	  		FOR j := 1 TO IMAGE_SIZE DO                             (* de eerste maal getekend *)
	    		Plot( j, i, gColorMap[BridgeBeeld[i][j]]);
	    		END;
  		END;
		GetImage(1, 1, IMAGE_SIZE, IMAGE_SIZE, BridgeRc.id);            (* de brugtile wordt gesaved*)
	END;

	FOR i := 1 TO NBR_COLUMNS DO                       		(* Speelveld tekenen *)
  		FOR j := 1 TO NBR_ROWS DO
		Speelveld[i][j].kollom:=i;
		Speelveld[i][j].rij:=j;
		NEW(Speelveld[i][j].soort);
		Speelveld[i][j].soort^:=GrasRc;
		TekenTile(Speelveld[i][j]);
	        END;
   	END;
	
	rdmPlaceRvr1:=RandomCard(4,NBR_ROWS-3);                        (* er wordt random een *)
	rdmPlaceRvr2:=RandomCard(4,NBR_ROWS-3);                        (* rivier gegenereerd  *)
	rdmPlaceRvr3:=RandomCard(4,NBR_ROWS-3);
	rdmTurnRvr1:=RandomCard(2,4);
	rdmTurnRvr2:=RandomCard(6,NBR_ROWS-1);
	
	FOR i := 1 TO rdmTurnRvr1 DO
		Speelveld[rdmPlaceRvr1][i].soort^:=RivierRc;
		TekenTile(Speelveld[rdmPlaceRvr1][i]);
	END;
	
	IF rdmPlaceRvr1<rdmPlaceRvr2 THEN
		FOR i := rdmPlaceRvr1 TO rdmPlaceRvr2 DO
			Speelveld[i][rdmTurnRvr1].soort^:=RivierRc;
			TekenTile(Speelveld[i][rdmTurnRvr1]);
		END;
	ELSE    FOR i := rdmPlaceRvr2 TO rdmPlaceRvr1 DO
			Speelveld[i][rdmTurnRvr1].soort^:=RivierRc;
			TekenTile(Speelveld[i][rdmTurnRvr1]);
		END;
	END;
	
	FOR i := rdmTurnRvr1 TO rdmTurnRvr2 DO
		Speelveld[rdmPlaceRvr2][i].soort^:=RivierRc;
		TekenTile(Speelveld[rdmPlaceRvr2][i]);
	END;
	
	IF rdmPlaceRvr2<rdmPlaceRvr3 THEN
		FOR i := rdmPlaceRvr2 TO rdmPlaceRvr3 DO
			Speelveld[i][rdmTurnRvr2].soort^:=RivierRc;
			TekenTile(Speelveld[i][rdmTurnRvr2]);
		END;
	ELSE    FOR i := rdmPlaceRvr3 TO rdmPlaceRvr2 DO
			Speelveld[i][rdmTurnRvr2].soort^:=RivierRc;
			TekenTile(Speelveld[i][rdmTurnRvr2]);
		END;
	END;
	
	FOR i := rdmTurnRvr2 TO NBR_ROWS DO
		Speelveld[rdmPlaceRvr3][i].soort^:=RivierRc;
		TekenTile(Speelveld[rdmPlaceRvr3][i]);
	END;
	
	IF RandomCard(1,2)= 1 THEN                                      (* er worden random 1 of *)
		rdmBrug1:=RandomCard(rdmTurnRvr1+1,rdmTurnRvr2-1);      (* 2 bruggen gegenereerd *)
		Speelveld[rdmPlaceRvr2][rdmBrug1].soort^:=BridgeRc;
		TekenTile(Speelveld[rdmPlaceRvr2][rdmBrug1]);
		rdmBrug2:=0;
	ELSE	rdmBrug1:=RandomCard(1,rdmTurnRvr1-1);
		rdmBrug2:=RandomCard(rdmTurnRvr2+1,NBR_ROWS);
		Speelveld[rdmPlaceRvr1][rdmBrug1].soort^:=BridgeRc;
		TekenTile(Speelveld[rdmPlaceRvr1][rdmBrug1]);
		Speelveld[rdmPlaceRvr3][rdmBrug2].soort^:=BridgeRc;
		TekenTile(Speelveld[rdmPlaceRvr3][rdmBrug2]);
	END;
	
	rdmMaxNbrRocks:=RandomCard(3, 7);                                   (* er wordt random een aantal *)
	nbrRocks:=0;                                                        (* rotsen gegenereerd         *)
	REPEAT
	rdmRock1:=RandomCard(3, NBR_ROWS-2);
	rdmRock2:=RandomCard(1, NBR_ROWS);
	IF (Speelveld[rdmRock1][rdmRock2].soort^.id=GrasRc.id) AND (rdmRock2#rdmBrug1) AND (rdmRock2#rdmBrug2) THEN
		Speelveld[rdmRock1][rdmRock2].soort^:=RockRc;
		TekenTile(Speelveld[rdmRock1][rdmRock2]);
		INC(nbrRocks);
	END;	
	UNTIL nbrRocks=rdmMaxNbrRocks;
	
	Rectangle ( SCREEN_WIDTH-MENU_SIZE, 0, SCREEN_WIDTH, SCREEN_HIGHT, _clrWHITE, TRUE); (* menu wordt getekend *)
	Rectangle ( SCREEN_WIDTH-MENU_SIZE+20, 305, SCREEN_WIDTH-20, 555, _clrBLACK, TRUE);
	TekenKnop ( SCREEN_WIDTH-MENU_SIZE, 200, SCREEN_WIDTH-VAL(CARDINAL, MENU_SIZE/2+1), 250, _clrBLUE, _clrWHITE, "Move/Attack");
	TekenKnop ( SCREEN_WIDTH-VAL(CARDINAL,MENU_SIZE/2), 200, SCREEN_WIDTH, 250, _clrBLUE, _clrWHITE, "Shoot");
	TekenKnop ( SCREEN_WIDTH-MENU_SIZE, SCREEN_HIGHT-92, SCREEN_WIDTH, SCREEN_HIGHT-62, _clrBLUE, _clrCYAN, "Cancel");
        TekenKnop ( SCREEN_WIDTH-MENU_SIZE, SCREEN_HIGHT-61, SCREEN_WIDTH, SCREEN_HIGHT-31, _clrBLUE, _clrCYAN, "End Turn");
	TekenKnop ( SCREEN_WIDTH-MENU_SIZE, SCREEN_HIGHT-30, SCREEN_WIDTH, SCREEN_HIGHT, _clrBLUE, _clrCYAN, "Retreat");
	RawOutText( SCREEN_WIDTH-MENU_SIZE+25, 334, _clrLIGHTCYAN, "Men                :");
	RawOutText( SCREEN_WIDTH-MENU_SIZE+25, 360, _clrLIGHTCYAN, "Hit points        :");
	RawOutText( SCREEN_WIDTH-MENU_SIZE+25, 386, _clrLIGHTCYAN, "Attack              :");
	RawOutText( SCREEN_WIDTH-MENU_SIZE+25, 412, _clrLIGHTCYAN, "Range	            :");
	RawOutText( SCREEN_WIDTH-MENU_SIZE+25, 438, _clrLIGHTCYAN, "Ranged attack:");
	RawOutText( SCREEN_WIDTH-MENU_SIZE+25, 464, _clrLIGHTCYAN, "Ammo             :");
	RawOutText( SCREEN_WIDTH-MENU_SIZE+25, 490, _clrLIGHTCYAN, "Endurance      :");
	
	CASE BattleScreenUnitsArr[1][pea].men OF 0 :                                    (* de units van de aanvaller worden geplaatst *)
	| 1	:
		TekenUnit(BattleScreenUnitsArr[1][pea], Speelveld[2][5]);
		Speelveld[2][5].inhoud^.health:=Speelveld[2][5].inhoud^.healthPerUnit;
	| 2	:
		TekenUnit(BattleScreenUnitsArr[1][pea], Speelveld[2][5]);
		TekenUnit(BattleScreenUnitsArr[1][pea], Speelveld[2][6]);
		Speelveld[2][5].inhoud^.men:=1;
		Speelveld[2][6].inhoud^.men:=1;
		Speelveld[2][5].inhoud^.health:=Speelveld[2][5].inhoud^.healthPerUnit;
		Speelveld[2][6].inhoud^.health:=Speelveld[2][6].inhoud^.healthPerUnit;
	| 3	:
		TekenUnit(BattleScreenUnitsArr[1][pea], Speelveld[2][4]);
		TekenUnit(BattleScreenUnitsArr[1][pea], Speelveld[2][5]);
		TekenUnit(BattleScreenUnitsArr[1][pea], Speelveld[2][6]);
		Speelveld[2][4].inhoud^.men:=1;
		Speelveld[2][5].inhoud^.men:=1;
		Speelveld[2][6].inhoud^.men:=1;
		Speelveld[2][4].inhoud^.health:=Speelveld[2][4].inhoud^.healthPerUnit;
		Speelveld[2][5].inhoud^.health:=Speelveld[2][5].inhoud^.healthPerUnit;
		Speelveld[2][6].inhoud^.health:=Speelveld[2][6].inhoud^.healthPerUnit;
	ELSE    TekenUnit(BattleScreenUnitsArr[1][pea], Speelveld[2][4]);
		TekenUnit(BattleScreenUnitsArr[1][pea], Speelveld[2][5]);
		TekenUnit(BattleScreenUnitsArr[1][pea], Speelveld[2][6]);
	        TekenUnit(BattleScreenUnitsArr[1][pea], Speelveld[2][7]);
		Speelveld[2][4].inhoud^.men:=BattleScreenUnitsArr[1][pea].men/4;
		Speelveld[2][5].inhoud^.men:=(BattleScreenUnitsArr[1][pea].men-Speelveld[2][4].inhoud^.men)/3;
		Speelveld[2][6].inhoud^.men:=(BattleScreenUnitsArr[1][pea].men-(Speelveld[2][4].inhoud^.men+Speelveld[2][5].inhoud^.men))/2;
		Speelveld[2][7].inhoud^.men:=BattleScreenUnitsArr[1][pea].men-(Speelveld[2][4].inhoud^.men+Speelveld[2][5].inhoud^.men+Speelveld[2][6].inhoud^.men);
		Speelveld[2][4].inhoud^.health:=Speelveld[2][4].inhoud^.healthPerUnit*Speelveld[2][4].inhoud^.men;
		Speelveld[2][5].inhoud^.health:=Speelveld[2][5].inhoud^.healthPerUnit*Speelveld[2][5].inhoud^.men;
		Speelveld[2][6].inhoud^.health:=Speelveld[2][6].inhoud^.healthPerUnit*Speelveld[2][6].inhoud^.men;
		Speelveld[2][7].inhoud^.health:=Speelveld[2][7].inhoud^.healthPerUnit*Speelveld[2][7].inhoud^.men;
	END;
	BattleScreenUnitsArr[1][pea].men:=0;
	CASE BattleScreenUnitsArr[1][inf].men OF 0	:
	| 1	:
		TekenUnit(BattleScreenUnitsArr[1][inf], Speelveld[1][6]);
		Speelveld[1][6].inhoud^.health:=Speelveld[1][6].inhoud^.healthPerUnit;
	| 2	:
		TekenUnit(BattleScreenUnitsArr[1][inf], Speelveld[1][4]);
		TekenUnit(BattleScreenUnitsArr[1][inf], Speelveld[1][6]);
		Speelveld[1][4].inhoud^.men:=1;
		Speelveld[1][6].inhoud^.men:=1;
		Speelveld[1][4].inhoud^.health:=Speelveld[1][4].inhoud^.healthPerUnit;
		Speelveld[1][6].inhoud^.health:=Speelveld[1][6].inhoud^.healthPerUnit;
	ELSE    TekenUnit(BattleScreenUnitsArr[1][inf], Speelveld[1][4]);
		TekenUnit(BattleScreenUnitsArr[1][inf], Speelveld[1][6]);
		TekenUnit(BattleScreenUnitsArr[1][inf], Speelveld[1][7]);
		Speelveld[1][4].inhoud^.men:=BattleScreenUnitsArr[1][inf].men/3;
		Speelveld[1][6].inhoud^.men:=(BattleScreenUnitsArr[1][inf].men-Speelveld[1][4].inhoud^.men)/2;
		Speelveld[1][7].inhoud^.men:=BattleScreenUnitsArr[1][inf].men-(Speelveld[1][4].inhoud^.men+Speelveld[1][6].inhoud^.men);
		Speelveld[1][4].inhoud^.health:=Speelveld[1][4].inhoud^.healthPerUnit*Speelveld[1][4].inhoud^.men;
		Speelveld[1][6].inhoud^.health:=Speelveld[1][6].inhoud^.healthPerUnit*Speelveld[1][6].inhoud^.men;
		Speelveld[1][7].inhoud^.health:=Speelveld[1][7].inhoud^.healthPerUnit*Speelveld[1][7].inhoud^.men;
	END;
	BattleScreenUnitsArr[1][inf].men:=0;
	IF BattleScreenUnitsArr[1][cav].men=1 THEN
		TekenUnit(BattleScreenUnitsArr[1][cav], Speelveld[2][3]);
		Speelveld[2][3].inhoud^.health:=Speelveld[2][3].inhoud^.healthPerUnit;
	ELSIF BattleScreenUnitsArr[1][cav].men>1 THEN
		TekenUnit(BattleScreenUnitsArr[1][cav], Speelveld[2][3]);
		TekenUnit(BattleScreenUnitsArr[1][cav], Speelveld[2][8]);
		Speelveld[2][3].inhoud^.men:=BattleScreenUnitsArr[1][cav].men/2;
		Speelveld[2][8].inhoud^.men:=BattleScreenUnitsArr[1][cav].men-Speelveld[2][3].inhoud^.men;
		Speelveld[2][3].inhoud^.health:=Speelveld[2][3].inhoud^.healthPerUnit*Speelveld[2][3].inhoud^.men;
		Speelveld[2][8].inhoud^.health:=Speelveld[2][8].inhoud^.healthPerUnit*Speelveld[2][8].inhoud^.men;
	END;
	BattleScreenUnitsArr[1][cav].men:=0;
	IF BattleScreenUnitsArr[1][art].men#0 THEN
		TekenUnit(BattleScreenUnitsArr[1][art], Speelveld[1][5]);
		Speelveld[1][5].inhoud^.men:=BattleScreenUnitsArr[1][art].men;
		Speelveld[1][5].inhoud^.health:=Speelveld[1][5].inhoud^.healthPerUnit*Speelveld[1][5].inhoud^.men;
	END;
        BattleScreenUnitsArr[1][art].men:=0;

	
	CASE BattleScreenUnitsArr[2][pea].men OF 0 :                                (* de units van de verdediger worden geplaatst*)
	| 1	:
		TekenUnit(BattleScreenUnitsArr[2][pea], Speelveld[NBR_COLUMNS-1][5]);
		Speelveld[NBR_COLUMNS-1][5].inhoud^.health:=Speelveld[NBR_COLUMNS-1][5].inhoud^.healthPerUnit;
	| 2	:
		TekenUnit(BattleScreenUnitsArr[2][pea], Speelveld[NBR_COLUMNS-1][5]);
		TekenUnit(BattleScreenUnitsArr[2][pea], Speelveld[NBR_COLUMNS-1][6]);
		Speelveld[NBR_COLUMNS-1][5].inhoud^.men:=1;
		Speelveld[NBR_COLUMNS-1][6].inhoud^.men:=1;
		Speelveld[NBR_COLUMNS-1][5].inhoud^.health:=Speelveld[NBR_COLUMNS-1][5].inhoud^.healthPerUnit;
		Speelveld[NBR_COLUMNS-1][6].inhoud^.health:=Speelveld[NBR_COLUMNS-1][6].inhoud^.healthPerUnit;
	| 3	:
		TekenUnit(BattleScreenUnitsArr[2][pea], Speelveld[NBR_COLUMNS-1][4]);
		TekenUnit(BattleScreenUnitsArr[2][pea], Speelveld[NBR_COLUMNS-1][5]);
		TekenUnit(BattleScreenUnitsArr[2][pea], Speelveld[NBR_COLUMNS-1][6]);
		Speelveld[NBR_COLUMNS-1][4].inhoud^.men:=1;
		Speelveld[NBR_COLUMNS-1][5].inhoud^.men:=1;
		Speelveld[NBR_COLUMNS-1][6].inhoud^.men:=1;
		Speelveld[NBR_COLUMNS-1][4].inhoud^.health:=Speelveld[NBR_COLUMNS-1][4].inhoud^.healthPerUnit;
		Speelveld[NBR_COLUMNS-1][5].inhoud^.health:=Speelveld[NBR_COLUMNS-1][5].inhoud^.healthPerUnit;
		Speelveld[NBR_COLUMNS-1][6].inhoud^.health:=Speelveld[NBR_COLUMNS-1][6].inhoud^.healthPerUnit;
	ELSE    TekenUnit(BattleScreenUnitsArr[2][pea], Speelveld[NBR_COLUMNS-1][4]);
		TekenUnit(BattleScreenUnitsArr[2][pea], Speelveld[NBR_COLUMNS-1][5]);
		TekenUnit(BattleScreenUnitsArr[2][pea], Speelveld[NBR_COLUMNS-1][6]);
	        TekenUnit(BattleScreenUnitsArr[2][pea], Speelveld[NBR_COLUMNS-1][7]);
		Speelveld[NBR_COLUMNS-1][4].inhoud^.men:=BattleScreenUnitsArr[2][pea].men/4;
		Speelveld[NBR_COLUMNS-1][5].inhoud^.men:=(BattleScreenUnitsArr[2][pea].men-Speelveld[NBR_COLUMNS-1][4].inhoud^.men)/3;
		Speelveld[NBR_COLUMNS-1][6].inhoud^.men:=(BattleScreenUnitsArr[2][pea].men-(Speelveld[NBR_COLUMNS-1][4].inhoud^.men+Speelveld[NBR_COLUMNS-1][5].inhoud^.men))/2;
		Speelveld[NBR_COLUMNS-1][7].inhoud^.men:=BattleScreenUnitsArr[2][pea].men-(Speelveld[NBR_COLUMNS-1][4].inhoud^.men+Speelveld[NBR_COLUMNS-1][5].inhoud^.men+Speelveld[NBR_COLUMNS-1][6].inhoud^.men);
		Speelveld[NBR_COLUMNS-1][4].inhoud^.health:=Speelveld[NBR_COLUMNS-1][4].inhoud^.healthPerUnit*Speelveld[NBR_COLUMNS-1][4].inhoud^.men;
		Speelveld[NBR_COLUMNS-1][5].inhoud^.health:=Speelveld[NBR_COLUMNS-1][5].inhoud^.healthPerUnit*Speelveld[NBR_COLUMNS-1][5].inhoud^.men;
		Speelveld[NBR_COLUMNS-1][6].inhoud^.health:=Speelveld[NBR_COLUMNS-1][6].inhoud^.healthPerUnit*Speelveld[NBR_COLUMNS-1][6].inhoud^.men;
		Speelveld[NBR_COLUMNS-1][7].inhoud^.health:=Speelveld[NBR_COLUMNS-1][7].inhoud^.healthPerUnit*Speelveld[NBR_COLUMNS-1][7].inhoud^.men;
	END;
	BattleScreenUnitsArr[2][pea].men:=0;
	CASE BattleScreenUnitsArr[2][inf].men OF 0	:
	| 1	:
		TekenUnit(BattleScreenUnitsArr[2][inf], Speelveld[NBR_COLUMNS][6]);
		Speelveld[NBR_COLUMNS][6].inhoud^.health:=Speelveld[NBR_COLUMNS][6].inhoud^.healthPerUnit;
	| 2	:
		TekenUnit(BattleScreenUnitsArr[2][inf], Speelveld[NBR_COLUMNS][4]);
		TekenUnit(BattleScreenUnitsArr[2][inf], Speelveld[NBR_COLUMNS][6]);
		Speelveld[NBR_COLUMNS][4].inhoud^.men:=1;
		Speelveld[NBR_COLUMNS][6].inhoud^.men:=1;
		Speelveld[NBR_COLUMNS][4].inhoud^.health:=Speelveld[NBR_COLUMNS][4].inhoud^.healthPerUnit;
		Speelveld[NBR_COLUMNS][6].inhoud^.health:=Speelveld[NBR_COLUMNS][6].inhoud^.healthPerUnit;
	ELSE    TekenUnit(BattleScreenUnitsArr[2][inf], Speelveld[NBR_COLUMNS][4]);
		TekenUnit(BattleScreenUnitsArr[2][inf], Speelveld[NBR_COLUMNS][6]);
		TekenUnit(BattleScreenUnitsArr[2][inf], Speelveld[NBR_COLUMNS][7]);
		Speelveld[NBR_COLUMNS][4].inhoud^.men:=BattleScreenUnitsArr[2][inf].men/3;
		Speelveld[NBR_COLUMNS][6].inhoud^.men:=(BattleScreenUnitsArr[2][inf].men-Speelveld[NBR_COLUMNS][4].inhoud^.men)/2;
		Speelveld[NBR_COLUMNS][7].inhoud^.men:=BattleScreenUnitsArr[2][inf].men-(Speelveld[NBR_COLUMNS][4].inhoud^.men+Speelveld[NBR_COLUMNS][6].inhoud^.men);
		Speelveld[NBR_COLUMNS][4].inhoud^.health:=Speelveld[NBR_COLUMNS][4].inhoud^.healthPerUnit*Speelveld[NBR_COLUMNS][4].inhoud^.men;
		Speelveld[NBR_COLUMNS][6].inhoud^.health:=Speelveld[NBR_COLUMNS][6].inhoud^.healthPerUnit*Speelveld[NBR_COLUMNS][6].inhoud^.men;
		Speelveld[NBR_COLUMNS][7].inhoud^.health:=Speelveld[NBR_COLUMNS][7].inhoud^.healthPerUnit*Speelveld[NBR_COLUMNS][7].inhoud^.men;
	END;
	BattleScreenUnitsArr[2][inf].men:=0;
	IF BattleScreenUnitsArr[2][cav].men=1 THEN
		TekenUnit(BattleScreenUnitsArr[2][cav], Speelveld[NBR_COLUMNS-1][3]);
		Speelveld[NBR_COLUMNS-1][3].inhoud^.health:=Speelveld[NBR_COLUMNS-1][3].inhoud^.healthPerUnit;
	ELSIF BattleScreenUnitsArr[2][cav].men>1 THEN
		TekenUnit(BattleScreenUnitsArr[2][cav], Speelveld[NBR_COLUMNS-1][3]);
		TekenUnit(BattleScreenUnitsArr[2][cav], Speelveld[NBR_COLUMNS-1][8]);
		Speelveld[NBR_COLUMNS-1][3].inhoud^.men:=BattleScreenUnitsArr[2][cav].men/2;
		Speelveld[NBR_COLUMNS-1][8].inhoud^.men:=BattleScreenUnitsArr[2][cav].men-Speelveld[NBR_COLUMNS-1][3].inhoud^.men;
		Speelveld[NBR_COLUMNS-1][3].inhoud^.health:=Speelveld[NBR_COLUMNS-1][3].inhoud^.healthPerUnit*Speelveld[NBR_COLUMNS-1][3].inhoud^.men;
		Speelveld[NBR_COLUMNS-1][8].inhoud^.health:=Speelveld[NBR_COLUMNS-1][8].inhoud^.healthPerUnit*Speelveld[NBR_COLUMNS-1][8].inhoud^.men;
	END;
	BattleScreenUnitsArr[2][cav].men:=0;
	IF BattleScreenUnitsArr[2][art].men#0 THEN
		TekenUnit(BattleScreenUnitsArr[2][art], Speelveld[NBR_COLUMNS][5]);
		Speelveld[NBR_COLUMNS][5].inhoud^.men:=BattleScreenUnitsArr[2][art].men;
		Speelveld[NBR_COLUMNS][5].inhoud^.health:=Speelveld[NBR_COLUMNS][5].inhoud^.healthPerUnit*Speelveld[NBR_COLUMNS][5].inhoud^.men;
	END;
	BattleScreenUnitsArr[2][art].men:=0;	
	END InitBattleScreen;
	
	
	
    PROCEDURE EndBattleScreen();
    	VAR i, j	: CARDINAL;
	BEGIN
		FOR i := 1 TO NBR_COLUMNS DO
  			FOR j := 1 TO NBR_ROWS DO
			Speelveld[i][j].inhoud:=NIL;
			Speelveld[i][j].soort:=NIL;		
			END;
   		END;
		ClearTekst;
	END EndBattleScreen;

	
	
(*		DE MUIS-PROCEDURES		*)
(************************************************)	
    PROCEDURE CheckMove(VAR Tile : SpeelveldTileRc);            (* procedure die de move-optie nagaat *)
      	VAR i, nbr			: CARDINAL;
    	BEGIN
		TekenMoveOptions(Tile, _clrLIGHTYELLOW, _clrLIGHTMAGENTA);
		LOOP
			IF UpdateMouse() THEN
			IF IsButtonPressed(LEFT_BUTTON) THEN
				IF GetMouseY()>0 THEN                                                               (* muisklik in het venster?*)
					IF  VAL(CARDINAL, GetMouseX()/IMAGE_SIZE)+1 <= NBR_COLUMNS THEN             (* muisklik in het speelveld?*)
					
				IF ( ( (Tile.kollom=VAL(CARDINAL, GetMouseX()/IMAGE_SIZE+1) ) AND (VAL(INTEGER,Tile.inhoud^.movesThisTurn)>=ABS(VAL(INTEGER, Tile.rij)-VAL(INTEGER, GetMouseY()/IMAGE_SIZE+1) )-1 ) )          (*muisklik binnen de juiste  *)
				OR ( (Tile.rij=VAL(CARDINAL, GetMouseY()/IMAGE_SIZE+1)) AND (VAL(INTEGER,Tile.inhoud^.movesThisTurn)>=ABS(VAL(INTEGER, GetMouseX()/IMAGE_SIZE+1)-VAL(INTEGER,Tile.kollom) )-1) ) ) THEN        (*verplaatsing(in de juiste  *)
					                                                                                                                                                                                       (*kollom of rij en binnen het*)
					nbr:=0;                                                                                                                                                                                (*aantal toegelaten vakjes?  *)
					IF  Tile.kollom> VAL(CARDINAL, (GetMouseX()/IMAGE_SIZE)+1) THEN                               (* de IF's gaan na of dat het gekozen vakje een geldige keuze is *)
						FOR i:=Tile.kollom  TO  VAL(CARDINAL, (GetMouseX()/IMAGE_SIZE)+2) BY -1 DO
							IF ( (Speelveld[i][Tile.rij].inhoud#NIL)  AND (i#Tile.kollom)) OR (NOT Speelveld[i][Tile.rij].soort^.toegankelijk) THEN
							nbr:=1;
							END;
						END;
					ELSIF Tile.kollom< VAL(CARDINAL, (GetMouseX()/IMAGE_SIZE)+1) THEN
						FOR i:=Tile.kollom  TO  VAL(CARDINAL, (GetMouseX()/IMAGE_SIZE)) DO
							IF ( (Speelveld[i][Tile.rij].inhoud#NIL) AND (i#Tile.kollom)) OR (NOT Speelveld[i][Tile.rij].soort^.toegankelijk) THEN
							nbr:=1;
							END;
						END;
					ELSE
					    IF  Tile.rij> VAL(CARDINAL, (GetMouseY()/IMAGE_SIZE)+1) THEN
						FOR i:=Tile.rij  TO VAL(CARDINAL, (GetMouseY()/IMAGE_SIZE)+2) BY -1 DO
							IF ( (Speelveld[Tile.kollom][i].inhoud#NIL) AND (i#Tile.rij)) OR (NOT Speelveld[Tile.kollom][i].soort^.toegankelijk) THEN
							nbr:=1;
							END;
						END;
					    ELSE
						FOR i:=Tile.rij  TO VAL(CARDINAL, (GetMouseY()/IMAGE_SIZE)) DO
							IF ( (Speelveld[Tile.kollom][i].inhoud#NIL) AND (i#Tile.rij)) OR (NOT Speelveld[Tile.kollom][i].soort^.toegankelijk) THEN
							nbr:=1;
							END;
						END;
					    END;
					END;
						
					IF (nbr=0) AND (Speelveld[VAL(CARDINAL, (GetMouseX()/IMAGE_SIZE)+1)][VAL(CARDINAL, (GetMouseY()/IMAGE_SIZE)+1)].soort^.toegankelijk)
					AND (Speelveld[VAL(CARDINAL, (GetMouseX()/IMAGE_SIZE)+1)][VAL(CARDINAL, (GetMouseY()/IMAGE_SIZE)+1)].inhoud=NIL)
					AND (VAL(INTEGER,Tile.inhoud^.movesThisTurn)>=ABS(VAL(INTEGER, Tile.rij)-VAL(INTEGER, GetMouseY()/IMAGE_SIZE+1))+ABS(VAL(INTEGER, GetMouseX()/IMAGE_SIZE+1)-VAL(INTEGER,Tile.kollom)) )THEN			
					StrCopy(NieuweTekst,Tile.inhoud^.name);
					StrConcatenate(NieuweTekst, ' Moves');
					VoegTekstToe1(NieuweTekst);
					
					PlaySound(MOVE1, MOVE2);
					(*IF RandomCard(1,2)=1 THEN
						PlaySoundEvent(MOVE1);
					ELSE
						PlaySoundEvent(MOVE2);
					END;*)
					
					MoveUnit(Tile,Speelveld[VAL(CARDINAL, (GetMouseX()/IMAGE_SIZE)+1)][VAL(CARDINAL, (GetMouseY()/IMAGE_SIZE)+1)]);
					Tile:=Speelveld[VAL(CARDINAL, (GetMouseX()/IMAGE_SIZE)+1)][VAL(CARDINAL, (GetMouseY()/IMAGE_SIZE)+1)];
					EXIT;
					ELSIF (nbr=0) AND (Speelveld[VAL(CARDINAL, (GetMouseX()/IMAGE_SIZE)+1)][VAL(CARDINAL, (GetMouseY()/IMAGE_SIZE)+1)].inhoud#NIL)
					AND (Speelveld[VAL(CARDINAL, (GetMouseX()/IMAGE_SIZE)+1)][VAL(CARDINAL, (GetMouseY()/IMAGE_SIZE)+1)].inhoud^.side#Player) THEN
					AttackUnit(Tile,Speelveld[VAL(CARDINAL, (GetMouseX()/IMAGE_SIZE)+1)][VAL(CARDINAL, (GetMouseY()/IMAGE_SIZE)+1)]);
					EXIT;
					END;
					
				END;                                                                                          (*end IF muisklik binnen de toegelaten verplaatsing?*)
				
					ELSIF (GetMouseY()>=SCREEN_HIGHT-92) AND (GetMouseY()<=SCREEN_HIGHT-62) THEN          (*muisklik in het menu (cancelknop)?*)
						TekenMoveOptions(Tile, _clrBLACK, _clrBLACK);
	                                        EXIT;
					END;                                                                                  (*end IF waar muisklik*)
				END;                     (*end IF muis binnen scherm*)
			END;                             (*end IF buttonpressed*)
			END;                             (*end IF updatemouse*)
	
		END;                                     (* end loop*)
	END CheckMove;
	
	
	
    PROCEDURE CheckShoot(Tile : SpeelveldTileRc);        (* procedure die de shoot-optie nagaat *)
    	BEGIN
	     TekenShootOptions(Tile, _clrLIGHTMAGENTA);
		LOOP
			IF UpdateMouse() THEN
			IF IsButtonPressed(LEFT_BUTTON)=TRUE THEN
				IF GetMouseY()>0 THEN		(* muisklik binnen scherm? *)
					IF  VAL(CARDINAL, GetMouseX()/IMAGE_SIZE)+1 <= NBR_COLUMNS THEN
						IF (ABS(VAL(INTEGER, GetMouseX()/IMAGE_SIZE)+1-VAL(INTEGER, Tile.kollom))+ABS(VAL(INTEGER, GetMouseY()/IMAGE_SIZE)+1-VAL(INTEGER,Tile.rij))>=2)
						AND NOT ( (Tile.inhoud^.range>=5) AND (ABS( VAL(INTEGER, GetMouseX()/IMAGE_SIZE)+1-VAL(INTEGER, Tile.kollom) )+ABS( VAL(INTEGER, GetMouseY()/IMAGE_SIZE)+1-VAL(INTEGER,Tile.rij) )<3) )
						AND (ABS(VAL(INTEGER, GetMouseX()/IMAGE_SIZE)+1-VAL(INTEGER, Tile.kollom))+ABS(VAL(INTEGER, GetMouseY()/IMAGE_SIZE)+1-VAL(INTEGER,Tile.rij))<=VAL(INTEGER, Tile.inhoud^.range)) THEN
							IF Shoot(Tile, Speelveld[GetMouseX()/IMAGE_SIZE+1][GetMouseY()/IMAGE_SIZE+1]) THEN
							EXIT;
							END;
						END;
						
					ELSIF (GetMouseY()>=SCREEN_HIGHT-92) AND (GetMouseY()<=SCREEN_HIGHT-62) THEN   (* wordt de CANCEL-knop ingedrukt? *)
						TekenShootOptions(Tile, _clrBLACK);
	                                        EXIT;
					END;
				END;		(* end IF GetMouseY *)
			END;     	(* end IF Button*)
			END;     	(* end IF UpdateMouse*)
	
		END;		(* end LOOP*)
		
	END CheckShoot;
	
	
		
    PROCEDURE CheckMouse();      (* de hoofdprocedure die de opties van de speler nagaat*)
    	VAR i, j	:		CARDINAL;
	BEGIN
		IF Player=1 THEN
			VoegTekstToe1("Player 1's Turn");
			Rectangle(SCREEN_WIDTH-MENU_SIZE+50, 18,SCREEN_WIDTH-45,38, _clrBLACK, TRUE);
			RawOutText(SCREEN_WIDTH-MENU_SIZE+65, 20, _clrBROWN,"Attacker");
(*			DrawNumber(SCREEN_WIDTH-MENU_SIZE+110, 28, Attacker, _clrBROWN, _clrBLACK);       *)
		ELSE	VoegTekstToe1("Player 2's Turn");
			RawOutText(SCREEN_WIDTH-MENU_SIZE+60, 20, _clrLIGHTMAGENTA,"Defender");
(*			DrawNumber(SCREEN_WIDTH-MENU_SIZE+110, 28, Defender, _clrLIGHTMAGENTA, _clrBLACK);  *)
		END;
		
		FOR i:=1 TO NBR_COLUMNS DO            (* de 'endurance' en 'ammo' wordt aangevuld *)
			FOR j:=1 TO NBR_ROWS DO
			IF Speelveld[i][j].inhoud#NIL THEN
				Speelveld[i][j].inhoud^.movesThisTurn:=Speelveld[i][j].inhoud^.movesPerTurn;
				IF Speelveld[i][j].inhoud^.range>=2 THEN
					IF Match(Speelveld[i][j].inhoud^.name,"Infantry") THEN
						Speelveld[i][j].inhoud^.ammo:=BattleScreenUnitsArr[Speelveld[i][j].inhoud^.side][inf].ammo;
					ELSE    Speelveld[i][j].inhoud^.ammo:=BattleScreenUnitsArr[Speelveld[i][j].inhoud^.side][art].ammo;
                                        END;
				END;
			END;
			END;
		END;
		
		LOOP
			IF UpdateMouse() THEN
			IF IsButtonPressed(LEFT_BUTTON)=TRUE THEN
				IF GetMouseY()>0 THEN                     (* muisklik in speelscherm? *)
				IF  VAL(CARDINAL, GetMouseX()/IMAGE_SIZE)+1 <= NBR_COLUMNS THEN  (* muisklik in speelscherm? *)
					IF ActiveTile.inhoud#NIL THEN
						TekenSelectUnit(ActiveTile, _clrBLACK);
					END;
					ActiveTile:=Speelveld[VAL(CARDINAL, (GetMouseX()/IMAGE_SIZE)+1)][VAL(CARDINAL, (GetMouseY()/IMAGE_SIZE)+1)];
					SelectUnit(ActiveTile);
				ELSE;
					CASE  GetMouseY()  OF 200..250 :
						IF (ActiveTile.inhoud#NIL) AND (ActiveTile.inhoud^.side=Player)
						AND (GetMouseX()<=SCREEN_WIDTH-VAL(CARDINAL, MENU_SIZE/2+1)) THEN
							IF ActiveTile.inhoud^.movesThisTurn>0 THEN
							CheckMove(ActiveTile);
							SelectUnit(ActiveTile);
							END;
						ELSIF (ActiveTile.inhoud#NIL) AND (ActiveTile.inhoud^.side=Player) AND (ActiveTile.inhoud^.ammo>0) THEN
							CheckShoot(ActiveTile);
							SelectUnit(ActiveTile);
						END;
					| (SCREEN_HIGHT-30)..(SCREEN_HIGHT):
						FightOver:=TRUE;     			(*speler geeft op*)
						IF Player=Attacker THEN
							Winner:=Defender;
							FOR i:=1 TO NBR_COLUMNS DO
								FOR j:=1 TO NBR_ROWS DO
									IF (Speelveld[i][j].inhoud#NIL) AND (Speelveld[i][j].inhoud^.side=Defender) THEN
									IF Match(Speelveld[i][j].inhoud^.name,"Militia") THEN
										BattleScreenUnitsArr[2][pea].men:=BattleScreenUnitsArr[2][pea].men+Speelveld[i][j].inhoud^.men;
									ELSIF Match(Speelveld[i][j].inhoud^.name,"Infantry") THEN
										BattleScreenUnitsArr[2][inf].men:=BattleScreenUnitsArr[2][inf].men+Speelveld[i][j].inhoud^.men;
									ELSIF Match(Speelveld[i][j].inhoud^.name,"Cavalry") THEN
										BattleScreenUnitsArr[2][cav].men:=BattleScreenUnitsArr[2][cav].men+Speelveld[i][j].inhoud^.men;
									ELSE	
										BattleScreenUnitsArr[2][art].men:=Speelveld[i][j].inhoud^.men;
									END;
									END;
								END;
							END;
						ELSE 	Winner:=Attacker;
						END;
						EXIT;
					| (SCREEN_HIGHT-61)..(SCREEN_HIGHT-31):         (*speler stopt met zijn beurt*)
						FightOver:=TRUE;
						Winner:=Player;
						FOR i:=1 TO NBR_COLUMNS DO
							FOR j:=1 TO NBR_ROWS DO
								IF (Speelveld[i][j].inhoud#NIL) AND (Speelveld[i][j].inhoud^.side#Player) THEN      (*er wordt nagegaan of de tegenspeler*)
									FightOver:=FALSE;                                                           (*nog units heeft			 *)
									Winner:=0;
								END;
							END;
						END;
						IF Player=1 THEN         (* de beurt wordt doorgegeven *)
							Player:=2;
						ELSE Player:=1;
						END;
						EXIT;
					ELSE
					END;		
				END;            (* end IF muisklik in speelscherm? *)
				END;    	(* end IF GetMouseY *)
			END;            (* end IF Button*)
			END;		(* end IF UpdateMouse*)
		END;		(* end LOOP*)
	END CheckMouse;
	
	
PROCEDURE DoBattle(VAR AttackingCountry, DefendingCountry : CountryRe): BOOLEAN;
 VAR i, j		:CARDINAL;
     battleOutcome		: 		BOOLEAN;   (* TRUE = attacker wins, FALSE = defender wins*)
BEGIN
  WrLn;

BattleScreenUnitsArr[1][pea].range:=PlayerUnitsAr[AttackingCountry.owner][pea].range;
BattleScreenUnitsArr[1][inf].range:=PlayerUnitsAr[AttackingCountry.owner][inf].range;
BattleScreenUnitsArr[1][art].range:=PlayerUnitsAr[AttackingCountry.owner][art].range;
BattleScreenUnitsArr[1][cav].range:=PlayerUnitsAr[AttackingCountry.owner][cav].range;
BattleScreenUnitsArr[2][pea].range:=PlayerUnitsAr[DefendingCountry.owner][pea].range;
BattleScreenUnitsArr[2][cav].range:=PlayerUnitsAr[DefendingCountry.owner][cav].range;
BattleScreenUnitsArr[2][inf].range:=PlayerUnitsAr[DefendingCountry.owner][inf].range;
BattleScreenUnitsArr[2][art].range:=PlayerUnitsAr[DefendingCountry.owner][art].range;

BattleScreenUnitsArr[1][pea].attack:=PlayerUnitsAr[AttackingCountry.owner][pea].attack;
BattleScreenUnitsArr[1][inf].attack:=PlayerUnitsAr[AttackingCountry.owner][inf].attack;
BattleScreenUnitsArr[1][art].attack:=PlayerUnitsAr[AttackingCountry.owner][art].attack;
BattleScreenUnitsArr[1][cav].attack:=PlayerUnitsAr[AttackingCountry.owner][cav].attack;
BattleScreenUnitsArr[2][pea].attack:=PlayerUnitsAr[DefendingCountry.owner][pea].attack;
BattleScreenUnitsArr[2][cav].attack:=PlayerUnitsAr[DefendingCountry.owner][cav].attack;
BattleScreenUnitsArr[2][inf].attack:=PlayerUnitsAr[DefendingCountry.owner][inf].attack;
BattleScreenUnitsArr[2][art].attack:=PlayerUnitsAr[DefendingCountry.owner][art].attack;

BattleScreenUnitsArr[1][pea].rangedAttack:=PlayerUnitsAr[AttackingCountry.owner][pea].rangedAttack;
BattleScreenUnitsArr[1][inf].rangedAttack:=PlayerUnitsAr[AttackingCountry.owner][inf].rangedAttack;
BattleScreenUnitsArr[1][art].rangedAttack:=PlayerUnitsAr[AttackingCountry.owner][art].rangedAttack;
BattleScreenUnitsArr[1][cav].rangedAttack:=PlayerUnitsAr[AttackingCountry.owner][cav].rangedAttack;
BattleScreenUnitsArr[2][pea].rangedAttack:=PlayerUnitsAr[DefendingCountry.owner][pea].rangedAttack;
BattleScreenUnitsArr[2][cav].rangedAttack:=PlayerUnitsAr[DefendingCountry.owner][cav].rangedAttack;
BattleScreenUnitsArr[2][inf].rangedAttack:=PlayerUnitsAr[DefendingCountry.owner][inf].rangedAttack;
BattleScreenUnitsArr[2][art].rangedAttack:=PlayerUnitsAr[DefendingCountry.owner][art].rangedAttack;

BattleScreenUnitsArr[1][inf].ammo:=PlayerUnitsAr[AttackingCountry.owner][inf].ammo;
BattleScreenUnitsArr[1][art].ammo:=PlayerUnitsAr[AttackingCountry.owner][art].ammo;
BattleScreenUnitsArr[2][inf].ammo:=PlayerUnitsAr[DefendingCountry.owner][inf].ammo;
BattleScreenUnitsArr[2][art].ammo:=PlayerUnitsAr[DefendingCountry.owner][art].ammo;

BattleScreenUnitsArr[1][pea].healthPerUnit:=PlayerUnitsAr[AttackingCountry.owner][pea].hitPoints;
BattleScreenUnitsArr[1][inf].healthPerUnit:=PlayerUnitsAr[AttackingCountry.owner][inf].hitPoints;
BattleScreenUnitsArr[1][art].healthPerUnit:=PlayerUnitsAr[AttackingCountry.owner][art].hitPoints;
BattleScreenUnitsArr[1][cav].healthPerUnit:=PlayerUnitsAr[AttackingCountry.owner][cav].hitPoints;
BattleScreenUnitsArr[2][pea].healthPerUnit:=PlayerUnitsAr[DefendingCountry.owner][pea].hitPoints;
BattleScreenUnitsArr[2][cav].healthPerUnit:=PlayerUnitsAr[DefendingCountry.owner][cav].hitPoints;
BattleScreenUnitsArr[2][inf].healthPerUnit:=PlayerUnitsAr[DefendingCountry.owner][inf].hitPoints;
BattleScreenUnitsArr[2][art].healthPerUnit:=PlayerUnitsAr[DefendingCountry.owner][art].hitPoints;

BattleScreenUnitsArr[1][pea].movesPerTurn:=PlayerUnitsAr[AttackingCountry.owner][pea].endurance;
BattleScreenUnitsArr[1][inf].movesPerTurn:=PlayerUnitsAr[AttackingCountry.owner][inf].endurance;
BattleScreenUnitsArr[1][art].movesPerTurn:=PlayerUnitsAr[AttackingCountry.owner][art].endurance;
BattleScreenUnitsArr[1][cav].movesPerTurn:=PlayerUnitsAr[AttackingCountry.owner][cav].endurance;
BattleScreenUnitsArr[2][pea].movesPerTurn:=PlayerUnitsAr[DefendingCountry.owner][pea].endurance;
BattleScreenUnitsArr[2][cav].movesPerTurn:=PlayerUnitsAr[DefendingCountry.owner][cav].endurance;
BattleScreenUnitsArr[2][inf].movesPerTurn:=PlayerUnitsAr[DefendingCountry.owner][inf].endurance;
BattleScreenUnitsArr[2][art].movesPerTurn:=PlayerUnitsAr[DefendingCountry.owner][art].endurance;

BattleScreenUnitsArr[1][pea].men:=AttackingCountry.Peas;
BattleScreenUnitsArr[1][inf].men:=AttackingCountry.Inf;
BattleScreenUnitsArr[1][cav].men:=AttackingCountry.Cav;
BattleScreenUnitsArr[1][art].men:=AttackingCountry.Can;
BattleScreenUnitsArr[2][pea].men:=DefendingCountry.Peas;
BattleScreenUnitsArr[2][inf].men:=DefendingCountry.Inf;
BattleScreenUnitsArr[2][cav].men:=DefendingCountry.Cav;
BattleScreenUnitsArr[2][art].men:=DefendingCountry.Can;

gPseudoRandom:=FALSE;
InitBattleScreen();
TekenKnop ( SCREEN_WIDTH-MENU_SIZE+20, 60, SCREEN_WIDTH-20, 80, _clrCYAN, _clrBLUE, DefendingCountry.name);       (*!!!!*)

Attacker:=1;
Defender:=2;
Player:=Attacker;

FightOver:=FALSE;
LOOP                                      (* de eigenlijk game-LOOP *)
	CheckMouse();
	IF FightOver THEN
		EXIT;
	END;
END;
FOR i:=1 TO NBR_COLUMNS DO
	FOR j:=1 TO NBR_ROWS DO
		IF (Speelveld[i][j].inhoud#NIL) AND (Speelveld[i][j].inhoud^.side=Attacker) THEN
		IF Match(Speelveld[i][j].inhoud^.name,"Militia") THEN
			BattleScreenUnitsArr[1][pea].men:=BattleScreenUnitsArr[1][pea].men+Speelveld[i][j].inhoud^.men;
		ELSIF Match(Speelveld[i][j].inhoud^.name,"Infantry") THEN
			BattleScreenUnitsArr[1][inf].men:=BattleScreenUnitsArr[1][inf].men+Speelveld[i][j].inhoud^.men;
		ELSIF Match(Speelveld[i][j].inhoud^.name,"Cavalry") THEN
			BattleScreenUnitsArr[1][cav].men:=BattleScreenUnitsArr[1][cav].men+Speelveld[i][j].inhoud^.men;
		ELSE
			BattleScreenUnitsArr[1][art].men:=Speelveld[i][j].inhoud^.men;
		END;
		END;
	END;
END;
IF Winner=Attacker THEN
	battleOutcome:=TRUE;
	DefendingCountry.owner:=AttackingCountry.owner;
	DefendingCountry.Peas:=BattleScreenUnitsArr[1][pea].men;
	DefendingCountry.Inf:=BattleScreenUnitsArr[1][inf].men;
	DefendingCountry.Cav:=BattleScreenUnitsArr[1][cav].men;
	DefendingCountry.Can:=BattleScreenUnitsArr[1][art].men;
ELSE    AttackingCountry.Peas:=BattleScreenUnitsArr[1][pea].men;
	battleOutcome:=FALSE;
	AttackingCountry.Inf:=BattleScreenUnitsArr[1][inf].men;
	AttackingCountry.Cav:=BattleScreenUnitsArr[1][cav].men;
	AttackingCountry.Can:=BattleScreenUnitsArr[1][art].men;
	DefendingCountry.Peas:=BattleScreenUnitsArr[2][pea].men;
	DefendingCountry.Inf:=BattleScreenUnitsArr[2][inf].men;
	DefendingCountry.Cav:=BattleScreenUnitsArr[2][cav].men;
	DefendingCountry.Can:=BattleScreenUnitsArr[2][art].men;
END;
EndBattleScreen();
RETURN battleOutcome;
END DoBattle;


BEGIN
BattleScreenUnitsArr[1][cav].fileName:= "BSUnits/cav1.bmp";
BattleScreenUnitsArr[2][cav].fileName:= "BSUnits/cav2.bmp";
BattleScreenUnitsArr[1][inf].fileName:= "BSUnits/inf1.bmp";
BattleScreenUnitsArr[2][inf].fileName:= "BSUnits/inf2.bmp";
BattleScreenUnitsArr[1][art].fileName:= "BSUnits/art1.bmp";
BattleScreenUnitsArr[2][art].fileName:= "BSUnits/art2.bmp";
BattleScreenUnitsArr[1][pea].fileName:= "BSUnits/pea1.bmp";
BattleScreenUnitsArr[2][pea].fileName:= "BSUnits/pea2.bmp";

FOR i:=1 TO 2 DO
	BattleScreenUnitsArr[i][cav].name:="Cavalry";
	BattleScreenUnitsArr[i][inf].name:="Infantry";
	BattleScreenUnitsArr[i][art].name:="Artillery";
	BattleScreenUnitsArr[i][pea].name:="Militia";

	BattleScreenUnitsArr[i][cav].side:=i;
	BattleScreenUnitsArr[i][inf].side:=i;
	BattleScreenUnitsArr[i][art].side:=i;
	BattleScreenUnitsArr[i][pea].side:=i;
END;

InitUnits;
END BattleScreen.