MODULE ContinentalScreen;
 <* NOOPTIMIZE + *> <* WOFF + *>
 <* M2EXTENSIONS + *> <* STORAGE + *>

(* European Supremacy, 2006, gemaakt door Sybren Van der Straeten, Yannick Lefevre, Xenios Tillez in opdracht van VUB *)
(* Noot aan de lezer: we begonnen aan dit spel met de opvatting er een spel voor 1 tot x aantal spelers van te maken.
   Echter, gaandeweg zagen we in dat dit, met de keuzes die we in het begin gemaakt hadden, niet zou lukken.
   Derhalve hebben we onze doelstelling aangepast tot het maken van een spel voor exact 2 spelers. Het spel zal dus nit
   werken als NBR_PLAYERS#2.
   Nochtans zal een aandachtige lezer hier en daar opmerken dat er efficintere datastructuren zijn voor een 2-player-game. Het is dan
   ook onze bedoeling onderstaande code ooit aan te passen aan onze werkelijke doelstelling, en dus hebben we sommige
   'inefficinte' stukken niet vervangen door efficintere. Onze excuses voor eventuele verwarring die
   hieraan te wijten zou zijn. *)

(* IMPORTLIST *)

FROM StandardMouse IMPORT InitMouseGraphWindow, UpdateMouse, GetMouseY, GetMouseX, MouseButton, IsButtonPressed;
FROM IO IMPORT WrStr, WrLn, RdCard, WrCard, RdInt, WrInt, RdKey, RdLn;
FROM Lib IMPORT Delay;
FROM Graph IMPORT GetImage, Init, Line, Rectangle, Circle, Disc, Polygon, RawOutText, _clrBLACK, _clrBLUE, _clrGREEN, _clrCYAN, _clrRED, _clrMAGENTA;
FROM Graph IMPORT ClearScreen, _clrBROWN, _clrWHITE, _clrGRAY, _clrLIGHTBLUE, _clrLIGHTGREEN, _clrLIGHTCYAN, _clrLIGHTRED, _clrLIGHTMAGENTA, _clrLIGHTYELLOW, _clrBRIGHTWHITE,SetBkColor;
FROM ModifiedStandardBitmap IMPORT BITMAP_SIZE, DIGIT_SIZE, BitmapEn, DrawBitmap, DrawNumber, DrawDigit, DrawBitmapFile, DrawSavedBitmap, DrawBorderBitmapFile;
FROM StandardLib IMPORT MinCard, MaxCard, RandomCard, gPseudoRandom, SetSeed, Arrow, Distance, TestColours,StrLength,StrConcatenate;
FROM WholeStr IMPORT CardToStr;
FROM Str IMPORT Insert;
FROM BattleScreen IMPORT InitUnits, DoBattle, PlayerUnitsAr, UnitsEn, PlayerUnitsRc;
FROM StandardSound IMPORT SoundEventEn, InitSound, PlaySoundEvent;
FROM DefineType IMPORT NBR_COUNTRIES, CoordAr, String, linkCountry, CountryRe, NBR_PLAYERS;
FROM MenuScreen IMPORT IntroScreen, OutroScreen;

(* CONSTANTS *)

CONST SSX = 875;
      SSY = 700;
      MSX = 765;
      MSY = 453;
      LETTER_WIDTH = 8;
      DIFFX=MSX/12;
      DIFFY=(SSY-((SSY-MSY)/5+MSY))/14;
      INITX=(SSX-MSX)/2;
      INITY=(SSY-MSY)/5+MSY+DIFFY;




(* TYPE DECLARATIONS *)


TYPE PlayerRe = RECORD
	money : CARDINAL;
	clr : CARDINAL;
	END; (* Player *)
TYPE pSu = [1..NBR_PLAYERS];
TYPE cSu = [0..NBR_COUNTRIES+1];

(* VARIABLES *)
	
VAR i,gbmpID,gX,gY,gNbrMoves : CARDINAL;
    gEuropeAr : ARRAY [0..NBR_COUNTRIES] OF linkCountry;
    gActivePlayer : pSu;
    gActiveCountry,gCountryClicked : cSu;
    gPlayerAr : ARRAY [1..NBR_PLAYERS] OF PlayerRe;
    gGameStateBo,gMoveAttackBo,gEndTurnBo,gNewUnitsBo,gAttackBo,gWinnerBo : BOOLEAN;
    gNewUnits: CountryRe;


(* PROCEDURE DECLARATIONS *)

PROCEDURE ConvertCoordinates(x,y:CARDINAL;text:String):CoordAr;    (* converts given (x,y) to ((x1,y1),(x2,y2)) to draw rectangle with name of country *)
VAR res:CoordAr;                                                   (* Sybren *)
BEGIN
  res[1]:=x-VAL(CARDINAL,(StrLength(text)/2*LETTER_WIDTH))-10;
  res[2]:=y-8-4;
  res[3]:=x+VAL(CARDINAL,(StrLength(text)/2*LETTER_WIDTH))+10;
  res[4]:=y+8+4;
RETURN res;
END ConvertCoordinates;

PROCEDURE DrawCountry(country:CountryRe);                          (* Yannick *)
VAR 	id, width, height 	: CARDINAL;
	Padname			: String;
BEGIN   CardToStr(country.owner, Padname);
	Insert(Padname, country.name, 0);
	Insert(Padname, "CSpics/", 0);
	StrConcatenate(Padname, ".bmp");
	id :=DrawBitmapFile((SSX-MSX)/2, (SSY-MSY)/5, Padname, width, height );
END DrawCountry;

PROCEDURE DrawBorderCountry(country:CountryRe; color : CARDINAL);    (* Yannick *)
VAR 	Padname			: String;
BEGIN   Padname:="CSpics/";
	StrConcatenate(Padname, country.name);
	StrConcatenate(Padname, "1.bmp");
	DrawBorderBitmapFile((SSX-MSX)/2, (SSY-MSY)/5, Padname,color)
END DrawBorderCountry;

PROCEDURE DrawBackGround();                                        (* Yannick *)
VAR
BEGIN	Rectangle(0, 0, (SSX-MSX)/2-9, SSY, _clrBRIGHTWHITE, TRUE);
	Rectangle(0, (SSY-MSY)/5+MSY+11, SSX, SSY, _clrBRIGHTWHITE, TRUE);
	Rectangle((SSX-MSX)/2+MSX+10, 0, SSX, SSY, _clrBRIGHTWHITE, TRUE);
	Rectangle(0, 0, SSX, (SSY-MSY)/5-10, _clrBRIGHTWHITE, TRUE);
	
	Rectangle((SSX-MSX)/2-8, (SSY-MSY)/5-9, (SSX-MSX)/2-1, (SSY-MSY)/5+MSY+10, _clrCYAN, TRUE);
	Rectangle((SSX-MSX)/2-8, (SSY-MSY)/5+MSY+2, (SSX-MSX)/2+MSX+9, (SSY-MSY)/5+MSY+10, _clrCYAN, TRUE);
	Rectangle((SSX-MSX)/2+MSX+3, (SSY-MSY)/5-9, (SSX-MSX)/2+MSX+9, (SSY-MSY)/5+MSY+10, _clrCYAN, TRUE);
	Rectangle((SSX-MSX)/2-8, (SSY-MSY)/5-9, (SSX-MSX)/2+MSX+9, (SSY-MSY)/5-1,_clrCYAN, TRUE);
	
	Line((SSX-MSX)/2-10,(SSY-MSY)/5+MSY+10,(SSX-MSX)/2-2,(SSY-MSY)/5+MSY+1, _clrBLACK);
	Line((SSX-MSX)/2+MSX+9,(SSY-MSY)/5+MSY+10,(SSX-MSX)/2+MSX+2,(SSY-MSY)/5+MSY+1, _clrBLACK);
	Line((SSX-MSX)/2-9,(SSY-MSY)/5-10,(SSX-MSX)/2-1,(SSY-MSY)/5-1, _clrBLACK);
	Line((SSX-MSX)/2+MSX+8,(SSY-MSY)/5-10,(SSX-MSX)/2+MSX+2,(SSY-MSY)/5-1, _clrBLACK);

END DrawBackGround;

PROCEDURE InitCountries();                                          (* Sybren *)
VAR i : CARDINAL;
BEGIN

  NEW(gEuropeAr[0]);
  gEuropeAr[0]^.name:=('Benelux');
  gEuropeAr[0]^.x:=VAL(CARDINAL,VAL(REAL,MSX)*0.420);
  gEuropeAr[0]^.y:=VAL(CARDINAL,VAL(REAL,MSY)*0.317);
  gEuropeAr[0]^.vicin[0]:=3;
  gEuropeAr[0]^.vicin[1]:=4;
  gEuropeAr[0]^.vicin[2]:=5;

  NEW(gEuropeAr[1]);
  gEuropeAr[1]^.name:=('Bulgaria');
  gEuropeAr[1]^.x:=VAL(CARDINAL,VAL(REAL,MSX)*0.80 );
  gEuropeAr[1]^.y:=VAL(CARDINAL,VAL(REAL,MSY)*0.70 );
  gEuropeAr[1]^.vicin[0]:=11;
  gEuropeAr[1]^.vicin[1]:=12;
  gEuropeAr[1]^.vicin[2]:=15;
  gEuropeAr[1]^.vicin[3]:=10;
  gEuropeAr[1]^.vicin[4]:=17;


  NEW(gEuropeAr[2]);
  gEuropeAr[2]^.name:=('Denmark');
  gEuropeAr[2]^.x:=VAL(CARDINAL,VAL(REAL,MSX)*0.55  );
  gEuropeAr[2]^.y:=VAL(CARDINAL,VAL(REAL,MSY)*0.20  );
  gEuropeAr[2]^.vicin[0]:=3;
  gEuropeAr[2]^.vicin[1]:=14;

  NEW(gEuropeAr[3]);
  gEuropeAr[3]^.name:=('German Empire');
  gEuropeAr[3]^.x:=VAL(CARDINAL,VAL(REAL,MSX)*0.55 );
  gEuropeAr[3]^.y:=VAL(CARDINAL,VAL(REAL,MSY)*0.36 );
  gEuropeAr[3]^.vicin[0]:=0;
  gEuropeAr[3]^.vicin[1]:=2;
  gEuropeAr[3]^.vicin[2]:=4;
  gEuropeAr[3]^.vicin[3]:=10;
  gEuropeAr[3]^.vicin[4]:=13;
  gEuropeAr[3]^.vicin[5]:=16;

  NEW(gEuropeAr[4]);
  gEuropeAr[4]^.name:=('France');
  gEuropeAr[4]^.x:=VAL(CARDINAL,VAL(REAL,MSX)*0.35 );
  gEuropeAr[4]^.y:=VAL(CARDINAL,VAL(REAL,MSY)*0.48 );
  gEuropeAr[4]^.vicin[0]:=0;
  gEuropeAr[4]^.vicin[1]:=3;
  gEuropeAr[4]^.vicin[2]:=5;
  gEuropeAr[4]^.vicin[3]:=6;
  gEuropeAr[4]^.vicin[4]:=8;
  gEuropeAr[4]^.vicin[5]:=16;

  NEW(gEuropeAr[5]);
  gEuropeAr[5]^.name:=('United Kingdom');
  gEuropeAr[5]^.x:=VAL(CARDINAL,VAL(REAL,MSX)*0.33);
  gEuropeAr[5]^.y:=VAL(CARDINAL,VAL(REAL,MSY)*0.258);
  gEuropeAr[5]^.vicin[0]:=0;
  gEuropeAr[5]^.vicin[1]:=4;
  gEuropeAr[5]^.vicin[2]:=7;

  NEW(gEuropeAr[6]);
  gEuropeAr[6]^.name:=('Iberia');
  gEuropeAr[6]^.x:=VAL(CARDINAL,VAL(REAL,MSX)*0.18 );
  gEuropeAr[6]^.y:=VAL(CARDINAL,VAL(REAL,MSY)*0.72 );
  gEuropeAr[6]^.vicin[0]:=4;
  gEuropeAr[6]^.vicin[1]:=9;

  NEW(gEuropeAr[7]);
  gEuropeAr[7]^.name:=('Ireland');
  gEuropeAr[7]^.x:=VAL(CARDINAL,VAL(REAL,MSX)*0.23);
  gEuropeAr[7]^.y:=VAL(CARDINAL,VAL(REAL,MSY)*0.167);
  gEuropeAr[7]^.vicin[0]:=5;

  NEW(gEuropeAr[8]);
  gEuropeAr[8]^.name:=('Italy');
  gEuropeAr[8]^.x:=VAL(CARDINAL,VAL(REAL,MSX)*0.55 );
  gEuropeAr[8]^.y:=VAL(CARDINAL,VAL(REAL,MSY)*0.68 );
  gEuropeAr[8]^.vicin[0]:=4;
  gEuropeAr[8]^.vicin[1]:=10;
  gEuropeAr[8]^.vicin[2]:=15;
  gEuropeAr[8]^.vicin[3]:=16;

  NEW(gEuropeAr[9]);
  gEuropeAr[9]^.name:=('Northern Africa');
  gEuropeAr[9]^.x:=VAL(CARDINAL,VAL(REAL,MSX)*0.25 );
  gEuropeAr[9]^.y:=VAL(CARDINAL,VAL(REAL,MSY)*0.95 );
  gEuropeAr[9]^.vicin[0]:=6;

  NEW(gEuropeAr[10]);
  gEuropeAr[10]^.name:=('Austria - Hungary');
  gEuropeAr[10]^.x:=VAL(CARDINAL,VAL(REAL,MSX)*0.65 );
  gEuropeAr[10]^.y:=VAL(CARDINAL,VAL(REAL,MSY)*0.525);
  gEuropeAr[10]^.vicin[0]:=3;
  gEuropeAr[10]^.vicin[1]:=1;
  gEuropeAr[10]^.vicin[2]:=8;
  gEuropeAr[10]^.vicin[3]:=12;
  gEuropeAr[10]^.vicin[4]:=13;
  gEuropeAr[10]^.vicin[5]:=15;
  gEuropeAr[10]^.vicin[6]:=16;

  NEW(gEuropeAr[11]);
  gEuropeAr[11]^.name:=('Ottoman Empire');
  gEuropeAr[11]^.x:=VAL(CARDINAL,VAL(REAL,MSX)*0.91 );
  gEuropeAr[11]^.y:=VAL(CARDINAL,VAL(REAL,MSY)*0.83 );
  gEuropeAr[11]^.vicin[0]:=1;
  gEuropeAr[11]^.vicin[1]:=17;

  NEW(gEuropeAr[12]);
  gEuropeAr[12]^.name:=('Rumania');
  gEuropeAr[12]^.x:=VAL(CARDINAL,VAL(REAL,MSX)*0.81 );
  gEuropeAr[12]^.y:=VAL(CARDINAL,VAL(REAL,MSY)*0.59 );
  gEuropeAr[12]^.vicin[0]:=1;
  gEuropeAr[12]^.vicin[1]:=10;
  gEuropeAr[12]^.vicin[2]:=13;

  NEW(gEuropeAr[13]);
  gEuropeAr[13]^.name:=('Russia');
  gEuropeAr[13]^.x:=VAL(CARDINAL,VAL(REAL,MSX)*0.725);
  gEuropeAr[13]^.y:=VAL(CARDINAL,VAL(REAL,MSY)*0.333);
  gEuropeAr[13]^.vicin[0]:=3;
  gEuropeAr[13]^.vicin[1]:=10;
  gEuropeAr[13]^.vicin[2]:=12;

  NEW(gEuropeAr[14]);
  gEuropeAr[14]^.name:=('Scandinavia');
  gEuropeAr[14]^.x:=VAL(CARDINAL,VAL(REAL,MSX)*0.6 );
  gEuropeAr[14]^.y:=VAL(CARDINAL,VAL(REAL,MSY)*0.083);
  gEuropeAr[14]^.vicin[0]:=2;

  NEW(gEuropeAr[15]);
  gEuropeAr[15]^.name:=('Serbia');
  gEuropeAr[15]^.x:=VAL(CARDINAL,VAL(REAL,MSX)*0.65 );
  gEuropeAr[15]^.y:=VAL(CARDINAL,VAL(REAL,MSY)*0.65 );
  gEuropeAr[15]^.vicin[0]:=1;
  gEuropeAr[15]^.vicin[1]:=10;
  gEuropeAr[15]^.vicin[2]:=17;
  gEuropeAr[15]^.vicin[3]:=8;

  NEW(gEuropeAr[16]);
  gEuropeAr[16]^.name:=('Suisse');
  gEuropeAr[16]^.x:=VAL(CARDINAL,VAL(REAL,MSX)*0.48);
  gEuropeAr[16]^.y:=VAL(CARDINAL,VAL(REAL,MSY)*0.525);
  gEuropeAr[16]^.vicin[0]:=3;
  gEuropeAr[16]^.vicin[1]:=4;
  gEuropeAr[16]^.vicin[2]:=8;
  gEuropeAr[16]^.vicin[3]:=10;

  NEW(gEuropeAr[17]);
  gEuropeAr[17]^.name:=('Greece');
  gEuropeAr[17]^.x:=VAL(CARDINAL,VAL(REAL,MSX)*0.78);
  gEuropeAr[17]^.y:=VAL(CARDINAL,VAL(REAL,MSY)*0.8 );
  gEuropeAr[17]^.vicin[0]:=1;
  gEuropeAr[17]^.vicin[1]:=11;
  gEuropeAr[17]^.vicin[2]:=15;


END InitCountries;


PROCEDURE DivideEurope(nbr : CARDINAL);                             (* Sybren *)
VAR x,i,j, perPlayer : CARDINAL;
BEGIN
  gPseudoRandom:=FALSE;
  x:=0;
  FOR i:=0 TO 17 DO
    gEuropeAr[i]^.owner:=0;
  END; (* FOR *)
  IF (((NBR_COUNTRIES+1) MOD (nbr)) = 0) THEN
    FOR i:=1 TO nbr DO                    (* all players get the same number of countries *)
      FOR j:=1 TO (NBR_COUNTRIES+1)/nbr DO
        REPEAT
        x:=RandomCard(0,17);
        UNTIL gEuropeAr[x]^.owner = 0;
        gEuropeAr[x]^.owner:=i;
      END; (* FOR j *)                    (* to make sure no country is allocated to a player, then allocated to another one *)
    END; (* FOR i *)
  ELSE                                      (* number of countries can't be evenly split between all players *)
   (* perPlayer:=(NBR_COUNTRIES+1)/nbr;     (* all players get a certain amount of countries, the rest is divided randomly *)
    FOR j:=1 TO nbr DO
      FOR i:=(j-1)*perPlayer TO (j*perPlayer)-1 DO
        gEuropeAr[i]^.owner:=j;
      END; (* FOR i *)
    END; (* FOR j *)
    FOR i:=(j*perPlayer)-1 TO NBR_COUNTRIES DO
      x:=RandomCard(0,17);
      gEuropeAr[i]^.owner:=x;
    END; (* FOR *)  *)
  END; (* IF *)
END DivideEurope;

PROCEDURE StringAfterString(str1,str2:String):String;                       (* Sybren *)
VAR i : CARDINAL;
    res : String;
BEGIN
  FOR i:=1 TO StrLength(str1) DO
    res[i]:=str1[i];
  END; (* FOR i *)
  FOR i:=1 TO StrLength(str2) DO
    res[i+StrLength(str1)]:=str2[i];
  END; (* FOR i *)
  FOR i:=StrLength(str1)+StrLength(str2)+1 TO 45 DO
    res[i]:='';
  END; (* FOR i *)
RETURN res;
END StringAfterString;

PROCEDURE DrawButton(beginx, beginy, endx, endy : CARDINAL; clrText : CARDINAL; text:String);      (* Sybren *)
CONST clrButton = 6;
VAR oldCol:CARDINAL;
BEGIN
  oldCol:=SetBkColor(6);
  Rectangle (beginx, beginy, endx, endy, clrButton, TRUE);
  Rectangle (beginx, beginy, endx, endy, _clrBLACK, FALSE);
  Rectangle (beginx+1, beginy+1, endx-1, endy-1, _clrBLACK, FALSE);
  RawOutText (beginx+VAL(CARDINAL,VAL(REAL,(endx-beginx))*0.5)-VAL(CARDINAL,VAL(REAL,(VAL(CARDINAL,LETTER_WIDTH*StrLength(text))))/17*LETTER_WIDTH), beginy+VAL(CARDINAL,VAL(REAL,(endy-beginy))*0.5)-8, clrText,text);
  oldCol:=SetBkColor(oldCol);
END DrawButton;

PROCEDURE DrawUnitButton(beginx, beginy, endx, endy : CARDINAL; clrText : CARDINAL; nrP,nrI,nrCv,nrCn:CARDINAL);(* Sybren *)
CONST clrButton = 6;
VAR textP,textI,textCv,textCn,nrPs,nrIs,nrCvs,nrCns:String;
    oldCol:CARDINAL;
BEGIN
  oldCol:=SetBkColor(clrButton);
  Rectangle (beginx, beginy, endx, endy, clrButton, TRUE);
  Rectangle (beginx, beginy, endx, endy, _clrBLACK, FALSE);
  Rectangle (beginx+1, beginy+1, endx-1, endy-1, _clrBLACK, FALSE);
  CardToStr(nrP,nrPs);
  CardToStr(nrI,nrIs);
  CardToStr(nrCv,nrCvs);
  CardToStr(nrCn,nrCns);
  textP:=StringAfterString('Peasants : ',nrPs);
  textI:=StringAfterString('Infantry : ',nrIs);
  textCv:=StringAfterString('Cavalry : ',nrCvs);
  textCn:=StringAfterString('Cannons : ',nrCns);
  RawOutText (beginx+(endx-beginx)/2-(VAL(CARDINAL,LETTER_WIDTH*StrLength(textP)))/17*8, beginy-8+(endy-beginy)*1/5, clrText,textP);
  RawOutText (beginx+(endx-beginx)/2-(VAL(CARDINAL,LETTER_WIDTH*StrLength(textI)))/17*8, beginy-8+(endy-beginy)*2/5, clrText,textI);
  RawOutText (beginx+(endx-beginx)/2-(VAL(CARDINAL,LETTER_WIDTH*StrLength(textCv)))/17*8, beginy-8+(endy-beginy)*3/5, clrText,textCv);
  RawOutText (beginx+(endx-beginx)/2-(VAL(CARDINAL,LETTER_WIDTH*StrLength(textCn)))/17*8, beginy-8+(endy-beginy)*4/5, clrText,textCn);
  oldCol:=SetBkColor(oldCol);
END DrawUnitButton;

PROCEDURE PlayerString(p:CARDINAL):String;                                (* Sybren *)
VAR res,res1,ap : String;
BEGIN
res1:='Player to play : ';
CardToStr(p,ap);
res:=StringAfterString(res1,ap);
IF p=1 THEN
  res:=StringAfterString(res,' (blue)');
END;
IF p=2 THEN
  res:=StringAfterString(res,' (red)');
END;
(*
IF p=3 THEN
  res:=StringAfterString(res,' (yellow)');
END;
*)
RETURN res;
END PlayerString;

PROCEDURE MoneyString(p:CARDINAL):String;                             (* Sybren *)
VAR res,res1,mon : String;
BEGIN
res1:="Treasury : ";
CardToStr(p,mon);
res:=StringAfterString(res1,mon);
RETURN res;
END MoneyString;

PROCEDURE Output(t:String);                       (* puts a given string in the (constant) output-location *)
VAR                                               (* Sybren *)
BEGIN
  DrawButton(INITX+9*DIFFX/2,INITY+8*DIFFY,INITX+19*DIFFX/2,INITY+11*DIFFY,_clrLIGHTYELLOW,t);
END Output;
	
PROCEDURE DrawScreen;                              (* Sybren,Yannick *)
VAR i,j,width,height: CARDINAL;
    stringAP, stringMon : String;
BEGIN

  (* drawing the map *)
  gPlayerAr[1].clr:=_clrRED;
  gPlayerAr[2].clr:=_clrLIGHTMAGENTA;
(*gPlayerAr[3].clr:=_clrLIGHTYELLOW;*)

  IF gbmpID=0 THEN
  	Rectangle((SSX-MSX)/2, (SSY-MSY)/5,(SSX-MSX)/2+MSX+2, (SSY-MSY)/5+MSY+1,_clrRED, TRUE) ;
  	FOR i:=0 TO 17 DO
  		DrawCountry(gEuropeAr[i]^);
  	END;
  	GetImage((SSX-MSX)/2, (SSY-MSY)/5,(SSX-MSX)/2+MSX+1, (SSY-MSY)/5+MSY, gbmpID);
  END;

  FOR i:=0 TO NBR_COUNTRIES DO
    FOR j:=1 TO NBR_PLAYERS DO
      IF gEuropeAr[i]^.owner=j THEN 	
	DrawButton(gEuropeAr[i]^.drawCoord[1]+(SSX-MSX)/2,gEuropeAr[i]^.drawCoord[2]+(SSY-MSY)/5,gEuropeAr[i]^.drawCoord[3]+(SSX-MSX)/2,gEuropeAr[i]^.drawCoord[4]+(SSY-MSY)/5,gPlayerAr[j].clr,gEuropeAr[i]^.name);	
      END; (* IF gEuropeAr *)
    END; (* FOR j *)
  END; (* FOR *)

  (* drawing the menu *)
  FOR i:=1 TO 25 DO
  stringAP[i]:='0';
  stringMon[i]:='0';
  END; (* FOR i*)
  stringAP:=PlayerString(gActivePlayer);
  stringMon:=MoneyString(gPlayerAr[gActivePlayer].money);
  DrawButton(INITX,INITY,INITX+4*DIFFX,INITY+3*DIFFY,_clrLIGHTYELLOW,stringAP);                                 (* active Player *)
  DrawButton(INITX,INITY+4*DIFFY,INITX+4*DIFFX,INITY+7*DIFFY,_clrLIGHTYELLOW,stringMon);                        (* money *)
  DrawButton(INITX,INITY+8*DIFFY,INITX+4*DIFFX,INITY+11*DIFFY,_clrLIGHTYELLOW,gEuropeAr[gActiveCountry]^.name); (* active Country *)
  DrawUnitButton(INITX+9*DIFFX/2,INITY,INITX+19*DIFFX/2,INITY+7*DIFFY,_clrLIGHTYELLOW,gEuropeAr[gActiveCountry]^.Peas,gEuropeAr[gActiveCountry]^.Inf,gEuropeAr[gActiveCountry]^.Cav,gEuropeAr[gActiveCountry]^.Can);
  Output('Select a country');
  DrawButton(INITX+10*DIFFX,INITY,INITX+12*DIFFX,INITY+3*DIFFY,_clrLIGHTYELLOW,'Move / Attack');                       (* move / attack *)
  DrawButton(INITX+10*DIFFX,INITY+4*DIFFY,INITX+12*DIFFX,INITY+7*DIFFY,_clrLIGHTYELLOW,'End turn');           (* end turn for current player *)
  DrawButton(INITX+10*DIFFX,INITY+8*DIFFY,INITX+12*DIFFX,INITY+11*DIFFY,_clrLIGHTYELLOW,'Quit');              (* quit *)
END DrawScreen;	

PROCEDURE CheckWhichCountryClicked(x,y:CARDINAL):cSu;     (* returns 0..NBR_COUNTRIES for country clicked, returns NBR_COUNTRIES+1 when no country clicked *)
VAR i: CARDINAL;                                          (* Sybren *)
    res:cSu;
BEGIN
  x:=x-(SSX-MSX)/2;
  y:=y-(SSY-MSY)/5;
  res:=NBR_COUNTRIES+1;
  FOR i := 0 TO NBR_COUNTRIES DO
    IF ((gEuropeAr[i]^.drawCoord[1]<=x)
        AND (gEuropeAr[i]^.drawCoord[3]>=x)
	AND (gEuropeAr[i]^.drawCoord[2]<=y)
	AND (gEuropeAr[i]^.drawCoord[4]>=y))
    THEN res:=i;
    END; (* IF *)
  END; (* FOR *)
  RETURN res;
END CheckWhichCountryClicked;

PROCEDURE PrepareMoveAttack(ac:cSu);                       (* Sybren *)
VAR str:String;
BEGIN
  IF gEuropeAr[ac]^.owner#gActivePlayer THEN
  str:='Not your country';
  Output(str);
  ELSE
  str:='Waiting for country to move to ';
  gMoveAttackBo:=TRUE;
  Output(str);
  END; (* IF *)
END PrepareMoveAttack;

PROCEDURE UpdateAfterCountryClicked();                      (* Sybren *)
VAR
BEGIN
  DrawButton(INITX,INITY+8*DIFFY,INITX+4*DIFFX,INITY+11*DIFFY,_clrLIGHTYELLOW,gEuropeAr[gActiveCountry]^.name); (* active Country *)
  DrawUnitButton(INITX+9*DIFFX/2,INITY,INITX+19*DIFFX/2,INITY+7*DIFFY,_clrLIGHTYELLOW,gEuropeAr[gActiveCountry]^.Peas,gEuropeAr[gActiveCountry]^.Inf,gEuropeAr[gActiveCountry]^.Cav,gEuropeAr[gActiveCountry]^.Can);
  Output(StringAfterString('Selected ',gEuropeAr[gActiveCountry]^.name));
END UpdateAfterCountryClicked;

PROCEDURE MoveAttackPossible():CARDINAL;    (* return: 0 (not in vicin); 1 (attack possible); 2 (move possible) *)
VAR res,i:CARDINAL;                         (* Sybren *)
BEGIN
   res:=0;
   i:=0;
   REPEAT
     IF gEuropeAr[gActiveCountry]^.vicin[i]=gCountryClicked THEN
       res:=1;
     END; (* IF *)
   INC(i);
   UNTIL i=1+HIGH(gEuropeAr[gActiveCountry]^.vicin);
   IF res#0 THEN
     IF gEuropeAr[gActiveCountry]^.owner=gEuropeAr[gCountryClicked]^.owner THEN res:=2;
     ELSE res:=1;
     END; (* IF *)
   END; (* IF *)
   RETURN res;
END MoveAttackPossible;

PROCEDURE EndTurn(VAR p:pSu);                (* Sybren *)
BEGIN
  IF p=1 THEN
    p:=2;
  ELSE p:=1;
  END;
  gPlayerAr[p].money:=gPlayerAr[p].money+2000;
  gEndTurnBo:=FALSE;
END EndTurn;

PROCEDURE EndGame();
BEGIN
  gEndTurnBo:=FALSE;
  gGameStateBo:=FALSE;
END EndGame;

PROCEDURE PopUpUpgrade(act:pSu);             (* Sybren *)
CONST clrButton = 6;
      beginx=(SSX-MSX)/2+MSX/6;
      endx=(SSX-MSX)/2+5*MSX/6;
      beginy=(SSY-MSY)/5+MSY/6;
      endy=(SSY-MSY)/5+5*MSY/6;
      diffx=(endx-beginx)/10;
      diffy=(endy-beginy)/19;
      upgradeCost=2500;
VAR pease, infa, cava, cano: PlayerUnitsRc;
    oldCol,i,moneyLeft:CARDINAL;
    selected: UnitsEn;
    monStr: String;
BEGIN
  pease:=PlayerUnitsAr[act][pea];
  infa:=PlayerUnitsAr[act][inf];
  cava:=PlayerUnitsAr[act][cav];
  cano:=PlayerUnitsAr[act][art];

  oldCol:=SetBkColor(6);
  Rectangle (beginx, beginy, endx, endy, clrButton, TRUE);
  Rectangle (beginx, beginy, endx, endy, _clrBLACK, FALSE);
  Rectangle (beginx+1, beginy+1, endx-1, endy-1, _clrBLACK, FALSE);
  DrawButton(beginx+1*diffx, beginy+1*diffy, beginx+4*diffx, beginy+3*diffy, _clrLIGHTYELLOW, 'Peasants');       (* which type to adapt *)
  DrawButton(beginx+6*diffx, beginy+1*diffy, beginx+9*diffx, beginy+3*diffy, _clrLIGHTYELLOW, 'Infantry');
  DrawButton(beginx+1*diffx, beginy+4*diffy, beginx+4*diffx, beginy+6*diffy, _clrLIGHTYELLOW, 'Cavalry');
  DrawButton(beginx+6*diffx, beginy+4*diffy, beginx+9*diffx, beginy+6*diffy, _clrLIGHTYELLOW, 'Artillery');


  DrawButton(beginx+1*diffx, beginy+7*diffy, beginx+4*diffx, beginy+9*diffy, _clrLIGHTYELLOW, 'Hitpoints');    (* which ability to adapt *)
  DrawButton(beginx+1*diffx, beginy+10*diffy, beginx+4*diffx, beginy+12*diffy, _clrLIGHTYELLOW, 'Attack');
  DrawButton(beginx+1*diffx, beginy+13*diffy, beginx+4*diffx, beginy+15*diffy, _clrLIGHTYELLOW, 'Endurance');
  DrawButton(beginx+6*diffx, beginy+7*diffy, beginx+8*diffx, beginy+9*diffy, _clrLIGHTYELLOW, 'Range');
  DrawButton(beginx+6*diffx, beginy+10*diffy, beginx+8*diffx, beginy+12*diffy, _clrLIGHTYELLOW, 'Rgd Attack');
  DrawButton(beginx+6*diffx, beginy+13*diffy, beginx+8*diffx, beginy+15*diffy, _clrLIGHTYELLOW, 'Ammunition');


  FOR i:=1 TO 3 DO
    DrawButton(beginx+4*diffx, beginy+(7+(i-1)*3)*diffy, beginx+5*diffx, beginy+(9+(i-1)*3)*diffy, _clrLIGHTYELLOW, '+');
  END; (* FOR i *)

  FOR i:=1 TO 3 DO
    DrawButton(beginx+8*diffx, beginy+(7+(i-1)*3)*diffy, beginx+9*diffx, beginy+(9+(i-1)*3)*diffy, _clrLIGHTYELLOW, '+');
  END; (* FOR i *)

  CardToStr(gPlayerAr[act].money,monStr);
  selected:=pea;
  DrawButton(beginx+1*diffx, beginy+16*diffy, beginx+4*diffx, beginy+18*diffy, _clrLIGHTYELLOW, 'Selected peasants');
  DrawButton(beginx+5*diffx, beginy+16*diffy, beginx+7*diffx, beginy+18*diffy, _clrLIGHTYELLOW, StringAfterString('Left: ',monStr));
  DrawButton(beginx+8*diffx, beginy+16*diffy, beginx+9*diffx, beginy+18*diffy, _clrLIGHTYELLOW, 'Leave');
  moneyLeft:=gPlayerAr[act].money;
  LOOP
  IF UpdateMouse() THEN
     IF IsButtonPressed(LEFT_BUTTON) THEN
       IF ((GetMouseX()>=beginx) AND (GetMouseX()<=endx) AND (GetMouseY()>=beginy) AND (GetMouseY()<=endy)) THEN (* binnen popupvenster geklikt *)
       	 IF ((GetMouseX()>=beginx+8*diffx) AND (GetMouseX()<=beginx+9*diffx) AND (GetMouseY()>=beginy+16*diffy) AND (GetMouseY()<=beginy+18*diffy)) THEN (* Leave clicked *)
	   EXIT;
	 END; (* IF *)
         IF ((GetMouseX()>=beginx+1*diffx) AND (GetMouseX()<=beginx+9*diffx) AND (GetMouseY()>=beginy+1*diffy) AND (GetMouseY()<=beginy+6*diffy)) THEN (* veranderen type *)
	   CASE GetMouseX() OF
	     beginx+1*diffx..beginx+4*diffx:
	       CASE GetMouseY() OF
	         beginy+1*diffy..beginy+3*diffy: selected:=pea; DrawButton(beginx+1*diffx, beginy+16*diffy, beginx+4*diffx, beginy+18*diffy, _clrLIGHTYELLOW, 'Selected peasants');
		|beginy+4*diffy..beginy+6*diffy: selected:=cav; DrawButton(beginx+1*diffx, beginy+16*diffy, beginx+4*diffx, beginy+18*diffy, _clrLIGHTYELLOW, 'Selected cavalry');
		 ELSE;
	       END; (* CASE GetMouseY *)
	    |beginx+6*diffx..beginx+9*diffx:
	       CASE GetMouseY() OF
	         beginy+1*diffy..beginy+3*diffy: selected:=inf; DrawButton(beginx+1*diffx, beginy+16*diffy, beginx+4*diffx, beginy+18*diffy, _clrLIGHTYELLOW, 'Selected infantry');
		|beginy+4*diffy..beginy+6*diffy: selected:=art; DrawButton(beginx+1*diffx, beginy+16*diffy, beginx+4*diffx, beginy+18*diffy, _clrLIGHTYELLOW, 'Selected artillery');
		 ELSE;
	       END; (* CASE GetMouseY *)
	    ELSE;
	   END; (* CASE GetMouseX *)
	 END; (* veranderen type *)
	 IF ((GetMouseX()>=beginx+4*diffx) AND (GetMouseX()<=beginx+5*diffx) AND (GetMouseY()>=beginy+7*diffy) AND (GetMouseY()<=beginy+15*diffy)) THEN  (* veranderen eigenschappen *)
	   CASE GetMouseY() OF
	     beginy+7*diffy..beginy+9*diffy:
	       IF moneyLeft>=upgradeCost THEN
	         PlayerUnitsAr[act][selected].hitPoints:=PlayerUnitsAr[act][selected].hitPoints+1;
	         moneyLeft:=moneyLeft-upgradeCost;
		 CardToStr(moneyLeft,monStr);
		 DrawButton(beginx+5*diffx, beginy+16*diffy, beginx+7*diffx, beginy+18*diffy, _clrLIGHTYELLOW,StringAfterString('Left: ',monStr));
	       END;
	    |beginy+10*diffy..beginy+12*diffy:
	       IF moneyLeft>=upgradeCost THEN
	         PlayerUnitsAr[act][selected].attack:=PlayerUnitsAr[act][selected].attack+1;
		 moneyLeft:=moneyLeft-upgradeCost;
		 CardToStr(moneyLeft,monStr);
		 DrawButton(beginx+5*diffx, beginy+16*diffy, beginx+7*diffx, beginy+18*diffy, _clrLIGHTYELLOW, StringAfterString('Left: ',monStr));
	       END;
	    |beginy+13*diffy..beginy+15*diffy:
	       IF moneyLeft>=upgradeCost THEN  PlayerUnitsAr[act][selected].endurance:=PlayerUnitsAr[act][selected].endurance+1;
	         moneyLeft:=moneyLeft-upgradeCost;
	         CardToStr(moneyLeft,monStr);
	         DrawButton(beginx+5*diffx, beginy+16*diffy, beginx+7*diffx, beginy+18*diffy, _clrLIGHTYELLOW, StringAfterString('Left: ',monStr));
	       END;
	     ELSE;
	   END; (* GetMouseY() *)
	 END; (* GetMouseX() *)
	 IF ((GetMouseX()>=beginx+8*diffx) AND (GetMouseX()<=beginx+9*diffx) AND (GetMouseY()>=beginy+7*diffy) AND (GetMouseY()<=beginy+15*diffy)) THEN  (* veranderen eigenschappen *)
	   CASE GetMouseY() OF
	     beginy+7*diffy..beginy+9*diffy:
	       IF moneyLeft>=upgradeCost THEN
	        IF ((selected=inf) OR (selected=art)) THEN
	         PlayerUnitsAr[act][selected].range:=PlayerUnitsAr[act][selected].range+1;
	         moneyLeft:=moneyLeft-upgradeCost;
	         CardToStr(moneyLeft,monStr);
	         DrawButton(beginx+5*diffx, beginy+16*diffy, beginx+7*diffx, beginy+18*diffy, _clrLIGHTYELLOW, StringAfterString('Left: ',monStr));
		ELSE DrawButton(beginx+1*diffx, beginy+16*diffy, beginx+4*diffx, beginy+18*diffy, _clrLIGHTYELLOW, 'Have no range!');
		 Delay(1000);
		 IF selected=pea THEN DrawButton(beginx+1*diffx, beginy+16*diffy, beginx+4*diffx, beginy+18*diffy, _clrLIGHTYELLOW, 'Selected peasants');
		 ELSE DrawButton(beginx+1*diffx, beginy+16*diffy, beginx+4*diffx, beginy+18*diffy, _clrLIGHTYELLOW, 'Cavalry');
		 END;
		END; (* IF ranged *)
	       END;
	    |beginy+10*diffy..beginy+12*diffy:
	       IF moneyLeft>=upgradeCost THEN
	        IF ((selected=inf) OR (selected=art)) THEN
	         PlayerUnitsAr[act][selected].rangedAttack:=PlayerUnitsAr[act][selected].rangedAttack+1;
		 moneyLeft:=moneyLeft-upgradeCost;
		 CardToStr(moneyLeft,monStr);
		 DrawButton(beginx+5*diffx, beginy+16*diffy, beginx+7*diffx, beginy+18*diffy, _clrLIGHTYELLOW, StringAfterString('Left: ',monStr));
		ELSE DrawButton(beginx+1*diffx, beginy+16*diffy, beginx+4*diffx, beginy+18*diffy, _clrLIGHTYELLOW, 'Have no range!');
		 Delay(1000);
		 IF selected=pea THEN DrawButton(beginx+1*diffx, beginy+16*diffy, beginx+4*diffx, beginy+18*diffy, _clrLIGHTYELLOW, 'Selected peasants');
		 ELSE DrawButton(beginx+1*diffx, beginy+16*diffy, beginx+4*diffx, beginy+18*diffy, _clrLIGHTYELLOW, 'Cavalry');
		 END;
		END; (* IF ranged *)
	       END;
	    |beginy+13*diffy..beginy+15*diffy:
	       IF moneyLeft>=upgradeCost THEN
	        IF ((selected=inf) OR (selected=art)) THEN
	         PlayerUnitsAr[act][selected].ammo:=PlayerUnitsAr[act][selected].ammo+1;
		 moneyLeft:=moneyLeft-upgradeCost;
		 CardToStr(moneyLeft,monStr);
		 DrawButton(beginx+5*diffx, beginy+16*diffy, beginx+7*diffx, beginy+18*diffy, _clrLIGHTYELLOW, StringAfterString('Left: ',monStr));
		ELSE DrawButton(beginx+1*diffx, beginy+16*diffy, beginx+4*diffx, beginy+18*diffy, _clrLIGHTYELLOW, 'Have no range!');
		 Delay(1000);
		 IF selected=pea THEN DrawButton(beginx+1*diffx, beginy+16*diffy, beginx+4*diffx, beginy+18*diffy, _clrLIGHTYELLOW, 'Selected peasants');
		 ELSE DrawButton(beginx+1*diffx, beginy+16*diffy, beginx+4*diffx, beginy+18*diffy, _clrLIGHTYELLOW, 'Cavalry');
		 END;
		END; (* IF ranged *)
	       END;
	     ELSE;
	   END; (* GetMouseY() *)
	 END; (* GetMouseX() *)
        END; (* binnen pop up venster geklikt *)
       END; (* IsButtonPressed *)
   END; (* UpdateMouse *)
  END; (* LOOP *)
  gPlayerAr[act].money:=moneyLeft;
  oldCol:=SetBkColor(oldCol);
  ClearScreen(0);
  DrawBackGround;
  DrawSavedBitmap((SSX-MSX)/2, (SSY-MSY)/5, gbmpID);
  DrawScreen;
END PopUpUpgrade;

PROCEDURE PopUpMoveAttack(VAR peas,inf,cav,can:CARDINAL):BOOLEAN;                (* Sybren *)
CONST clrButton = 6;
      beginx=(SSX-MSX)/2+MSX/4;
      endx=(SSX-MSX)/2+3*MSX/4;
      beginy=(SSY-MSY)/5+MSY/4;
      endy=(SSY-MSY)/5+3*MSY/4;
      diffx=(endx-beginx)/11;
      diffy=(endy-beginy)/16;
VAR oldCol:CARDINAL;
    cntPeas,cntInf,cntCav,cntCan:CARDINAL;
    cntPeasS,cntInfS,cntCavS,cntCanS:String;
    res:BOOLEAN;
BEGIN
  oldCol:=SetBkColor(6);
  Rectangle (beginx, beginy, endx, endy, clrButton, TRUE);
  Rectangle (beginx, beginy, endx, endy, _clrBLACK, FALSE);
  Rectangle (beginx+1, beginy+1, endx-1, endy-1, _clrBLACK, FALSE);
  DrawButton(beginx+1*diffx,beginy+1*diffy,beginx+4*diffx,beginy+3*diffy,_clrLIGHTYELLOW,'Peasants'); (* peasantsknop *)
  DrawButton(beginx+1*diffx,beginy+4*diffy,beginx+4*diffx,beginy+6*diffy,_clrLIGHTYELLOW,'Infantry'); (* infantryknop *)
  DrawButton(beginx+1*diffx,beginy+7*diffy,beginx+4*diffx,beginy+9*diffy,_clrLIGHTYELLOW,'Cavalry'); (* cavalryknop *)
  DrawButton(beginx+1*diffx,beginy+10*diffy,beginx+4*diffx,beginy+12*diffy,_clrLIGHTYELLOW,'Cannons'); (* cannonknop *)
  DrawButton(beginx+5*diffx,beginy+1*diffy,beginx+6*diffx,beginy+3*diffy,_clrLIGHTYELLOW,'+');
  DrawButton(beginx+5*diffx,beginy+4*diffy,beginx+6*diffx,beginy+6*diffy,_clrLIGHTYELLOW,'+');
  DrawButton(beginx+5*diffx,beginy+7*diffy,beginx+6*diffx,beginy+9*diffy,_clrLIGHTYELLOW,'+');
  DrawButton(beginx+5*diffx,beginy+10*diffy,beginx+6*diffx,beginy+12*diffy,_clrLIGHTYELLOW,'+');
  DrawButton(beginx+7*diffx,beginy+1*diffy,beginx+8*diffx,beginy+3*diffy,_clrLIGHTYELLOW,'-');
  DrawButton(beginx+7*diffx,beginy+4*diffy,beginx+8*diffx,beginy+6*diffy,_clrLIGHTYELLOW,'-');
  DrawButton(beginx+7*diffx,beginy+7*diffy,beginx+8*diffx,beginy+9*diffy,_clrLIGHTYELLOW,'-');
  DrawButton(beginx+7*diffx,beginy+10*diffy,beginx+8*diffx,beginy+12*diffy,_clrLIGHTYELLOW,'-');
  cntPeas:=peas/2;
  cntInf:=inf/2;
  cntCav:=cav/2;
  cntCan:=can/2;
  CardToStr(cntPeas,cntPeasS);
  CardToStr(cntInf,cntInfS);
  CardToStr(cntCav,cntCavS);
  CardToStr(cntCan,cntCanS);
  DrawButton(beginx+9*diffx,beginy+1*diffy,beginx+10*diffx,beginy+3*diffy,_clrLIGHTYELLOW,cntPeasS); (* nr of peasants selected *)
  DrawButton(beginx+9*diffx,beginy+4*diffy,beginx+10*diffx,beginy+6*diffy,_clrLIGHTYELLOW,cntInfS);  (* nr of infantry selected *)
  DrawButton(beginx+9*diffx,beginy+7*diffy,beginx+10*diffx,beginy+9*diffy,_clrLIGHTYELLOW,cntCavS);  (* nr of cavalry selected *)
  DrawButton(beginx+9*diffx,beginy+10*diffy,beginx+10*diffx,beginy+12*diffy,_clrLIGHTYELLOW,cntCanS); (* nr of cannons selected *)
  DrawButton(beginx+1*diffx,beginy+13*diffy,beginx+4*diffx,beginy+15*diffy,_clrLIGHTYELLOW,'Cancel'); (* Cancel *)
  DrawButton(beginx+6*diffx,beginy+13*diffy,beginx+9*diffx,beginy+15*diffy,_clrLIGHTYELLOW,'Accept'); (* Accept *)
  oldCol:=SetBkColor(oldCol);

  LOOP
   IF UpdateMouse() THEN
     IF IsButtonPressed(LEFT_BUTTON) THEN
       IF ((GetMouseX()>=beginx) AND (GetMouseX()<=endx) AND (GetMouseY()>=beginy) AND (GetMouseY()<=endy)) THEN (* binnen popupvenster geklikt *)
         IF ((GetMouseX()>=beginx+5*diffx) AND (GetMouseX()<=beginx+6*diffx)) THEN
	   CASE GetMouseY() OF
	     beginy+1*diffy..beginy+3*diffy : IF ((cntPeas<peas) AND ((inf-cntInf>0) OR (cav-cntCav>0) OR (can-cntCan>0) OR (peas-cntPeas>=2))) THEN  cntPeas:=cntPeas+1; CardToStr(cntPeas,cntPeasS);DrawButton(beginx+9*diffx,beginy+1*diffy,beginx+10*diffx,beginy+3*diffy,_clrLIGHTYELLOW,cntPeasS);END; (* IF *)
	    |beginy+4*diffy..beginy+6*diffy : IF ((cntInf<inf) AND ((peas-cntPeas>0) OR (cav-cntCav>0) OR (can-cntCan>0) OR (inf-cntInf>=2))) THEN cntInf:=cntInf+1;  CardToStr(cntInf,cntInfS);DrawButton(beginx+9*diffx,beginy+4*diffy,beginx+10*diffx,beginy+6*diffy,_clrLIGHTYELLOW,cntInfS);END; (* IF *)
	    |beginy+7*diffy..beginy+9*diffy : IF ((cntCav<cav) AND ((peas-cntPeas>0) OR (inf-cntInf>0) OR (can-cntCan>0) OR (cav-cntCav>=2))) THEN cntCav:=cntCav+1;  CardToStr(cntCav,cntCavS);DrawButton(beginx+9*diffx,beginy+7*diffy,beginx+10*diffx,beginy+9*diffy,_clrLIGHTYELLOW,cntCavS);END; (* IF *)
	    |beginy+10*diffy..beginy+12*diffy : IF ((cntCan<can) AND ((peas-cntPeas>0) OR (inf-cntInf>0) OR (cav-cntCav>0) OR (can-cntCan>=2)))THEN cntCan:=cntCan+1;  CardToStr(cntCan,cntCanS);DrawButton(beginx+9*diffx,beginy+10*diffy,beginx+10*diffx,beginy+12*diffy,_clrLIGHTYELLOW,cntCanS); END; (* IF *)
	    ELSE;
	   END; (* CASE Y = INCREASE *)
	 END; (* X *)
	 IF ((GetMouseX()>=beginx+7*diffx) AND (GetMouseX()<=beginx+8*diffx)) THEN
	   CASE GetMouseY() OF
	     beginy+1*diffy..beginy+3*diffy : IF ((cntPeas>0) AND ((cntInf>0) OR (cntCav>0) OR (cntCan>0) OR (cntPeas>=2))) THEN cntPeas:=cntPeas-1; CardToStr(cntPeas,cntPeasS);DrawButton(beginx+9*diffx,beginy+1*diffy,beginx+10*diffx,beginy+3*diffy,_clrLIGHTYELLOW,cntPeasS);END; (* IF *)
	    |beginy+4*diffy..beginy+6*diffy : IF ((cntInf>0) AND ((cntPeas>0) OR (cntCav>0) OR (cntCan>0) OR (cntInf>=2))) THEN cntInf:=cntInf-1; CardToStr(cntInf,cntInfS);DrawButton(beginx+9*diffx,beginy+4*diffy,beginx+10*diffx,beginy+6*diffy,_clrLIGHTYELLOW,cntInfS);  END; (* IF *)
	    |beginy+7*diffy..beginy+9*diffy : IF ((cntCav>0) AND ((cntPeas>0) OR (cntInf>0) OR (cntCan>0) OR (cntCav>=2))) THEN cntCav:=cntCav-1; CardToStr(cntCav,cntCavS);DrawButton(beginx+9*diffx,beginy+7*diffy,beginx+10*diffx,beginy+9*diffy,_clrLIGHTYELLOW,cntCavS); END; (* IF *)
	    |beginy+10*diffy..beginy+12*diffy : IF ((cntCan>0) AND ((cntPeas>0) OR (cntInf>0) OR (cntCav>0) OR (cntCan>=2))) THEN cntCan:=cntCan-1; CardToStr(cntCan,cntCanS);DrawButton(beginx+9*diffx,beginy+10*diffy,beginx+10*diffx,beginy+12*diffy,_clrLIGHTYELLOW,cntCanS);END; (* IF *)
	    ELSE;
	   END; (* CASE Y = DECREASE *)
	 END; (* X *)
	 IF ((GetMouseX()>=beginx+1*diffx) AND (GetMouseX()<=beginx+4*diffx) AND (GetMouseY()>=beginy+13*diffy) AND (GetMouseY()<=beginy+15*diffy)) THEN
	   peas:=0;
	   inf:=0;
	   cav:=0;
	   can:=0;
	   res:=FALSE;
	   EXIT;
	 END; (* IF Cancel clicked *)
	 IF ((GetMouseX()>=beginx+6*diffx) AND (GetMouseX()<=beginx+9*diffx) AND (GetMouseY()>=beginy+13*diffy) AND (GetMouseY()<=beginy+15*diffy)) THEN
	   peas:=cntPeas;       (* variables are now the ones you want to move / attack with *)
	   inf:=cntInf;         (* variables are now the ones you want to move / attack with *)
	   cav:=cntCav;         (* variables are now the ones you want to move / attack with *)
	   can:=cntCan;         (* variables are now the ones you want to move / attack with *)
	   res:=TRUE;
	   EXIT;
	 END; (* IF Accept clicked *)
       END; (* IF Binnen pop up venster geklikt *)
     END; (* IF IsButtonPressed=LEFT *)
	 IF IsButtonPressed(RIGHT_BUTTON) THEN
	    IF ((GetMouseX()>=beginx) AND (GetMouseX()<=endx) AND (GetMouseY()>=beginy) AND (GetMouseY()<=endy)) THEN (* binnen popupvenster geklikt *)
         IF ((GetMouseX()>=beginx+5*diffx) AND (GetMouseX()<=beginx+6*diffx)) THEN
	   CASE GetMouseY() OF
	     beginy+1*diffy..beginy+3*diffy : IF cntPeas+9<peas THEN  cntPeas:=cntPeas+10; CardToStr(cntPeas,cntPeasS);DrawButton(beginx+9*diffx,beginy+1*diffy,beginx+10*diffx,beginy+3*diffy,_clrLIGHTYELLOW,cntPeasS);END; (* IF *)
	    |beginy+4*diffy..beginy+6*diffy : IF cntInf+9<inf THEN cntInf:=cntInf+10;  CardToStr(cntInf,cntInfS);DrawButton(beginx+9*diffx,beginy+4*diffy,beginx+10*diffx,beginy+6*diffy,_clrLIGHTYELLOW,cntInfS);END; (* IF *)
	    |beginy+7*diffy..beginy+9*diffy : IF cntCav+9<cav THEN cntCav:=cntCav+10;  CardToStr(cntCav,cntCavS);  DrawButton(beginx+9*diffx,beginy+7*diffy,beginx+10*diffx,beginy+9*diffy,_clrLIGHTYELLOW,cntCavS);END; (* IF *)
	    |beginy+10*diffy..beginy+12*diffy : IF cntCan+9<can THEN cntCan:=cntCan+10;  CardToStr(cntCan,cntCanS);   DrawButton(beginx+9*diffx,beginy+10*diffy,beginx+10*diffx,beginy+12*diffy,_clrLIGHTYELLOW,cntCanS); END; (* IF *)
	    ELSE;
	   END; (* CASE Y *)
	 END; (* X *)
	 IF ((GetMouseX()>=beginx+7*diffx) AND (GetMouseX()<=beginx+8*diffx)) THEN
	   CASE GetMouseY() OF
	     beginy+1*diffy..beginy+3*diffy : IF cntPeas>9 THEN cntPeas:=cntPeas-10; CardToStr(cntPeas,cntPeasS);DrawButton(beginx+9*diffx,beginy+1*diffy,beginx+10*diffx,beginy+3*diffy,_clrLIGHTYELLOW,cntPeasS);END; (* IF *)
	    |beginy+4*diffy..beginy+6*diffy : IF cntInf>9 THEN cntInf:=cntInf-10; CardToStr(cntInf,cntInfS);DrawButton(beginx+9*diffx,beginy+4*diffy,beginx+10*diffx,beginy+6*diffy,_clrLIGHTYELLOW,cntInfS);  END; (* IF *)
	    |beginy+7*diffy..beginy+9*diffy : IF cntCav>9 THEN cntCav:=cntCav-10; CardToStr(cntCav,cntCavS);DrawButton(beginx+9*diffx,beginy+7*diffy,beginx+10*diffx,beginy+9*diffy,_clrLIGHTYELLOW,cntCavS); END; (* IF *)
	    |beginy+10*diffy..beginy+12*diffy : IF cntCan>9 THEN cntCan:=cntCan-10; CardToStr(cntCan,cntCanS);DrawButton(beginx+9*diffx,beginy+10*diffy,beginx+10*diffx,beginy+12*diffy,_clrLIGHTYELLOW,cntCanS);END; (* IF *)
	    ELSE;
	   END; (* CASE Y *)
	 END; (* X *)
	 END; (* IF Binnen pop up venster geklikt *)
	 END; (* IF IsButtonPressed=RIGHT*)
   END; (* UpdateMouse *)
  END; (* LOOP *)
  RETURN res;
END PopUpMoveAttack;


PROCEDURE Move();                                            (* Sybren *)
VAR peas,inf,cav,can:CARDINAL;
    peasS,infS,cavS,canS:String;
    changed:BOOLEAN;
BEGIN
  peas:=gEuropeAr[gActiveCountry]^.Peas;
  inf:=gEuropeAr[gActiveCountry]^.Inf;
  cav:=gEuropeAr[gActiveCountry]^.Cav;
  can:=gEuropeAr[gActiveCountry]^.Can;
  changed:=PopUpMoveAttack(peas,inf,cav,can);
  gEuropeAr[gCountryClicked]^.Peas:=gEuropeAr[gCountryClicked]^.Peas+peas;
  gEuropeAr[gActiveCountry]^.Peas:=gEuropeAr[gActiveCountry]^.Peas-peas;
  gEuropeAr[gCountryClicked]^.Inf:=gEuropeAr[gCountryClicked]^.Inf+inf;
  gEuropeAr[gActiveCountry]^.Inf:=gEuropeAr[gActiveCountry]^.Inf-inf;
  gEuropeAr[gCountryClicked]^.Cav:=gEuropeAr[gCountryClicked]^.Cav+cav;
  gEuropeAr[gActiveCountry]^.Cav:=gEuropeAr[gActiveCountry]^.Cav-cav;
  gEuropeAr[gCountryClicked]^.Can:=gEuropeAr[gCountryClicked]^.Can+can;
  gEuropeAr[gActiveCountry]^.Can:=gEuropeAr[gActiveCountry]^.Can-can;
  ClearScreen(0);
  DrawBackGround;
  DrawSavedBitmap((SSX-MSX)/2, (SSY-MSY)/5, gbmpID);
  DrawScreen;
  CardToStr(peas,peasS);
  CardToStr(inf,infS);
  CardToStr(cav,cavS);
  CardToStr(can,canS);
  IF changed THEN
    Output(StringAfterString('Moved ',StringAfterString(peasS,StringAfterString(' peasants to ',gEuropeAr[gCountryClicked]^.name))));
    Delay(1000);
    Output(StringAfterString('Moved ',StringAfterString(infS,StringAfterString(' infantry to ',gEuropeAr[gCountryClicked]^.name))));
    Delay(1000);
    Output(StringAfterString('Moved ',StringAfterString(cavS,StringAfterString(' cavalry to ',gEuropeAr[gCountryClicked]^.name))));
    Delay(1000);
    Output(StringAfterString('Moved ',StringAfterString(canS,StringAfterString(' cannons to ',gEuropeAr[gCountryClicked]^.name))));
  END; (* IF changed *)
  gNbrMoves:=gNbrMoves+1;
END Move;

PROCEDURE CheckForWinner():BOOLEAN;                         (* Sybren *)
VAR res:BOOLEAN;
    nbr,i:CARDINAL;
BEGIN
  res:=TRUE;
  FOR i:=0 TO 17 DO
    IF gEuropeAr[i]^.owner#gActivePlayer
    THEN res:=FALSE;
    END;
  END;
  RETURN res;
END CheckForWinner;

PROCEDURE Battle();						(* Sybren *)
VAR peas,inf,cav,can:CARDINAL;
    attacker:CountryRe; (* temporary country that is needed in the BattleScreen-routine *)
    changed:BOOLEAN;
BEGIN
  peas:=gEuropeAr[gActiveCountry]^.Peas;
  inf:=gEuropeAr[gActiveCountry]^.Inf;
  cav:=gEuropeAr[gActiveCountry]^.Cav;
  can:=gEuropeAr[gActiveCountry]^.Can;
  changed:=PopUpMoveAttack(peas,inf,cav,can);
  attacker.name:=gEuropeAr[gActiveCountry]^.name;
  attacker.owner:=gEuropeAr[gActiveCountry]^.owner;
  attacker.x:=gEuropeAr[gActiveCountry]^.x;
  attacker.y:=gEuropeAr[gActiveCountry]^.y;
  attacker.Peas:=peas;
  attacker.Inf:=inf;
  attacker.Cav:=cav;
  attacker.Can:=can;
  attacker.vicin:=gEuropeAr[gActiveCountry]^.vicin;
  attacker.drawCoord:=gEuropeAr[gActiveCountry]^.drawCoord;
  gEuropeAr[gActiveCountry]^.Peas:=gEuropeAr[gActiveCountry]^.Peas-attacker.Peas;
  gEuropeAr[gActiveCountry]^.Inf:=gEuropeAr[gActiveCountry]^.Inf-attacker.Inf;
  gEuropeAr[gActiveCountry]^.Cav:=gEuropeAr[gActiveCountry]^.Cav-attacker.Cav;
  gEuropeAr[gActiveCountry]^.Can:=gEuropeAr[gActiveCountry]^.Can-attacker.Can;
  IF changed THEN
    PlaySoundEvent(TRUMPET);
    IF ( NOT DoBattle(attacker,gEuropeAr[gCountryClicked]^) ) THEN
	   	gEuropeAr[gActiveCountry]^.Peas:=gEuropeAr[gActiveCountry]^.Peas+attacker.Peas;
  		gEuropeAr[gActiveCountry]^.Inf:=gEuropeAr[gActiveCountry]^.Inf+attacker.Inf;
  		gEuropeAr[gActiveCountry]^.Cav:=gEuropeAr[gActiveCountry]^.Cav+attacker.Cav;
  		gEuropeAr[gActiveCountry]^.Can:=gEuropeAr[gActiveCountry]^.Can+attacker.Can;
	END; (* NOT DoBattle *)
  END; (* IF changed *)

  ClearScreen(0);
  DrawBackGround;
  DrawSavedBitmap((SSX-MSX)/2, (SSY-MSY)/5, gbmpID);
  IF gEuropeAr[gCountryClicked]^.owner=gEuropeAr[gActiveCountry]^.owner THEN
  	DrawCountry(gEuropeAr[gCountryClicked]^);
	GetImage((SSX-MSX)/2, (SSY-MSY)/5,(SSX-MSX)/2+MSX+1, (SSY-MSY)/5+MSY, gbmpID);
  END;
  DrawScreen;
  gNbrMoves:=gNbrMoves+1;
END Battle;

PROCEDURE PopUpBuy(act:pSu):BOOLEAN;                          (* Sybren *)
CONST clrButton = 6;
      beginx=(SSX-MSX)/2+MSX/4;
      endx=(SSX-MSX)/2+3*MSX/4;
      beginy=(SSY-MSY)/5+MSY/4;
      endy=(SSY-MSY)/5+3*MSY/4;
      diffx=(endx-beginx)/11;
      diffy=(endy-beginy)/16;
      peaCost=500;
      infCost=1000;
      cavCost=2000;
      artCost=4000;
VAR oldCol,moneyLeft:CARDINAL;
    cntPeas,cntInf,cntCav,cntCan:CARDINAL;
    cntPeasS,cntInfS,cntCavS,cntCanS,monStr:String;
    res:BOOLEAN;
VAR
BEGIN
  oldCol:=SetBkColor(6);
  Rectangle (beginx, beginy, endx, endy, clrButton, TRUE);
  Rectangle (beginx, beginy, endx, endy, _clrBLACK, FALSE);
  Rectangle (beginx+1, beginy+1, endx-1, endy-1, _clrBLACK, FALSE);
  DrawButton(beginx+1*diffx/2,beginy+1*diffy,beginx+4*diffx,beginy+3*diffy,_clrLIGHTYELLOW,'Peasants (500)'); (* peasantsknop *)
  DrawButton(beginx+1*diffx/2,beginy+4*diffy,beginx+4*diffx,beginy+6*diffy,_clrLIGHTYELLOW,'Infantry (1000)'); (* infantryknop *)
  DrawButton(beginx+1*diffx/2,beginy+7*diffy,beginx+4*diffx,beginy+9*diffy,_clrLIGHTYELLOW,'Cavalry (2000)'); (* cavalryknop *)
  DrawButton(beginx+1*diffx/2,beginy+10*diffy,beginx+4*diffx,beginy+12*diffy,_clrLIGHTYELLOW,'Cannons (4000)'); (* cannonknop *)
  DrawButton(beginx+5*diffx,beginy+1*diffy,beginx+6*diffx,beginy+3*diffy,_clrLIGHTYELLOW,'+');
  DrawButton(beginx+5*diffx,beginy+4*diffy,beginx+6*diffx,beginy+6*diffy,_clrLIGHTYELLOW,'+');
  DrawButton(beginx+5*diffx,beginy+7*diffy,beginx+6*diffx,beginy+9*diffy,_clrLIGHTYELLOW,'+');
  DrawButton(beginx+5*diffx,beginy+10*diffy,beginx+6*diffx,beginy+12*diffy,_clrLIGHTYELLOW,'+');
  DrawButton(beginx+7*diffx,beginy+1*diffy,beginx+8*diffx,beginy+3*diffy,_clrLIGHTYELLOW,'-');
  DrawButton(beginx+7*diffx,beginy+4*diffy,beginx+8*diffx,beginy+6*diffy,_clrLIGHTYELLOW,'-');
  DrawButton(beginx+7*diffx,beginy+7*diffy,beginx+8*diffx,beginy+9*diffy,_clrLIGHTYELLOW,'-');
  DrawButton(beginx+7*diffx,beginy+10*diffy,beginx+8*diffx,beginy+12*diffy,_clrLIGHTYELLOW,'-');
  gNewUnits.Peas:=0;
  gNewUnits.Inf:=0;
  gNewUnits.Cav:=0;
  gNewUnits.Can:=0;
  cntPeas:=gNewUnits.Peas;
  cntInf:=gNewUnits.Inf;
  cntCav:=gNewUnits.Cav;
  cntCan:=gNewUnits.Can;
  CardToStr(cntPeas,cntPeasS);
  CardToStr(cntInf,cntInfS);
  CardToStr(cntCav,cntCavS);
  CardToStr(cntCan,cntCanS);
  moneyLeft:=gPlayerAr[act].money;
  CardToStr(moneyLeft,monStr);
  DrawButton(beginx+9*diffx,beginy+1*diffy,beginx+10*diffx,beginy+3*diffy,_clrLIGHTYELLOW,cntPeasS); (* nr of peasants selected *)
  DrawButton(beginx+9*diffx,beginy+4*diffy,beginx+10*diffx,beginy+6*diffy,_clrLIGHTYELLOW,cntInfS);  (* nr of infantry selected *)
  DrawButton(beginx+9*diffx,beginy+7*diffy,beginx+10*diffx,beginy+9*diffy,_clrLIGHTYELLOW,cntCavS);  (* nr of cavalry selected *)
  DrawButton(beginx+9*diffx,beginy+10*diffy,beginx+10*diffx,beginy+12*diffy,_clrLIGHTYELLOW,cntCanS); (* nr of cannons selected *)
  DrawButton(beginx+1*diffx,beginy+13*diffy,beginx+4*diffx,beginy+15*diffy,_clrLIGHTYELLOW,StringAfterString('Left: ',monStr)); (* Cancel *)
  DrawButton(beginx+5*diffx,beginy+13*diffy,beginx+7*diffx,beginy+15*diffy,_clrLIGHTYELLOW,'Cancel'); (* Cancel *)
  DrawButton(beginx+8*diffx,beginy+13*diffy,beginx+10*diffx,beginy+15*diffy,_clrLIGHTYELLOW,'Accept'); (* Accept *)
  oldCol:=SetBkColor(oldCol);
  LOOP
   IF UpdateMouse() THEN
     IF IsButtonPressed(LEFT_BUTTON) THEN
       IF ((GetMouseX()>=beginx) AND (GetMouseX()<=endx) AND (GetMouseY()>=beginy) AND (GetMouseY()<=endy)) THEN (* binnen popupvenster geklikt *)
         IF ((GetMouseX()>=beginx+5*diffx) AND (GetMouseX()<=beginx+6*diffx)) THEN
	   CASE GetMouseY() OF
	     beginy+1*diffy..beginy+3*diffy : IF moneyLeft>=peaCost THEN  moneyLeft:=moneyLeft-peaCost;cntPeas:=cntPeas+1;CardToStr(moneyLeft,monStr);CardToStr(cntPeas,cntPeasS);DrawButton(beginx+9*diffx,beginy+1*diffy,beginx+10*diffx,beginy+3*diffy,_clrLIGHTYELLOW,cntPeasS);DrawButton(beginx+1*diffx,beginy+13*diffy,beginx+4*diffx,beginy+15*diffy,_clrLIGHTYELLOW,StringAfterString('Left: ',monStr));END; (* IF *)
	    |beginy+4*diffy..beginy+6*diffy : IF moneyLeft>=infCost THEN  moneyLeft:=moneyLeft-infCost;cntInf:=cntInf+1;CardToStr(moneyLeft,monStr);CardToStr(cntInf,cntInfS);DrawButton(beginx+9*diffx,beginy+4*diffy,beginx+10*diffx,beginy+6*diffy,_clrLIGHTYELLOW,cntInfS);  DrawButton(beginx+1*diffx,beginy+13*diffy,beginx+4*diffx,beginy+15*diffy,_clrLIGHTYELLOW,StringAfterString('Left: ',monStr));END; (* IF *)
	    |beginy+7*diffy..beginy+9*diffy : IF moneyLeft>=cavCost THEN  moneyLeft:=moneyLeft-cavCost;cntCav:=cntCav+1;CardToStr(moneyLeft,monStr);CardToStr(cntCav,cntCavS);DrawButton(beginx+9*diffx,beginy+7*diffy,beginx+10*diffx,beginy+9*diffy,_clrLIGHTYELLOW,cntCavS);  DrawButton(beginx+1*diffx,beginy+13*diffy,beginx+4*diffx,beginy+15*diffy,_clrLIGHTYELLOW,StringAfterString('Left: ',monStr));END; (* IF *)
	    |beginy+10*diffy..beginy+12*diffy : IF moneyLeft>=artCost THEN moneyLeft:=moneyLeft-artCost;cntCan:=cntCan+1;CardToStr(moneyLeft,monStr);CardToStr(cntCan,cntCanS);DrawButton(beginx+9*diffx,beginy+10*diffy,beginx+10*diffx,beginy+12*diffy,_clrLIGHTYELLOW,cntCanS);  DrawButton(beginx+1*diffx,beginy+13*diffy,beginx+4*diffx,beginy+15*diffy,_clrLIGHTYELLOW,StringAfterString('Left: ',monStr));END; (* IF *)
	    ELSE;
	   END; (* CASE Y = INCREASE *)
	 END; (* X *)
	 IF ((GetMouseX()>=beginx+7*diffx) AND (GetMouseX()<=beginx+8*diffx)) THEN
	   CASE GetMouseY() OF
	     beginy+1*diffy..beginy+3*diffy : IF (cntPeas>0)THEN cntPeas:=cntPeas-1;moneyLeft:=moneyLeft+peaCost;CardToStr(moneyLeft,monStr); CardToStr(cntPeas,cntPeasS);DrawButton(beginx+1*diffx,beginy+13*diffy,beginx+4*diffx,beginy+15*diffy,_clrLIGHTYELLOW,StringAfterString('Left: ',monStr));DrawButton(beginx+9*diffx,beginy+1*diffy,beginx+10*diffx,beginy+3*diffy,_clrLIGHTYELLOW,cntPeasS);END; (* IF *)
	    |beginy+4*diffy..beginy+6*diffy : IF (cntInf>0) THEN cntInf:=cntInf-1;moneyLeft:=moneyLeft+infCost;CardToStr(moneyLeft,monStr); CardToStr(cntInf,cntInfS);DrawButton(beginx+1*diffx,beginy+13*diffy,beginx+4*diffx,beginy+15*diffy,_clrLIGHTYELLOW,StringAfterString('Left: ',monStr));DrawButton(beginx+9*diffx,beginy+4*diffy,beginx+10*diffx,beginy+6*diffy,_clrLIGHTYELLOW,cntInfS);  END; (* IF *)
	    |beginy+7*diffy..beginy+9*diffy : IF (cntCav>0) THEN cntCav:=cntCav-1;moneyLeft:=moneyLeft+cavCost;CardToStr(moneyLeft,monStr); CardToStr(cntCav,cntCavS);DrawButton(beginx+1*diffx,beginy+13*diffy,beginx+4*diffx,beginy+15*diffy,_clrLIGHTYELLOW,StringAfterString('Left: ',monStr));DrawButton(beginx+9*diffx,beginy+7*diffy,beginx+10*diffx,beginy+9*diffy,_clrLIGHTYELLOW,cntCavS); END; (* IF *)
	    |beginy+10*diffy..beginy+12*diffy : IF (cntCan>0) THEN cntCan:=cntCan-1;moneyLeft:=moneyLeft+artCost;CardToStr(moneyLeft,monStr); CardToStr(cntCan,cntCanS);DrawButton(beginx+1*diffx,beginy+13*diffy,beginx+4*diffx,beginy+15*diffy,_clrLIGHTYELLOW,StringAfterString('Left: ',monStr));DrawButton(beginx+9*diffx,beginy+10*diffy,beginx+10*diffx,beginy+12*diffy,_clrLIGHTYELLOW,cntCanS);END; (* IF *)
	    ELSE;
	   END; (* CASE Y = DECREASE *)
	 END; (* X *)
	 IF ((GetMouseX()>=beginx+5*diffx) AND (GetMouseX()<=beginx+7*diffx) AND (GetMouseY()>=beginy+13*diffy) AND (GetMouseY()<=beginy+15*diffy)) THEN
	   gNewUnits.Peas:=0;
           gNewUnits.Inf:=0;
           gNewUnits.Cav:=0;
           gNewUnits.Can:=0;	
	   res:=FALSE;
	   EXIT;
	 END; (* IF Cancel clicked *)
	 IF ((GetMouseX()>=beginx+8*diffx) AND (GetMouseX()<=beginx+10*diffx) AND (GetMouseY()>=beginy+13*diffy) AND (GetMouseY()<=beginy+15*diffy)) THEN
	   gNewUnits.Peas:=cntPeas;
	   gNewUnits.Inf:=cntInf;
	   gNewUnits.Cav:=cntCav;
	   gNewUnits.Can:=cntCan;
	   gPlayerAr[act].money:=moneyLeft;	
	   res:=TRUE;
	   EXIT;
	 END; (* IF Accept clicked *)
       END; (* IF Binnen pop up venster geklikt *)
     END; (* IF IsButtonPressed=LEFT *)
   END; (* UpdateMouse *)
  END; (* LOOP *)
  RETURN res;
END PopUpBuy;

PROCEDURE PopUpChoose();                               (* Sybren *)
CONST beginx=(SSX-MSX)/2+MSX/4;
      endx=(SSX-MSX)/2+3*MSX/4;
      beginy=(SSY-MSY)/5+2*MSY/6;
      endy=(SSY-MSY)/5+4*MSY/6;
      diffx=(endx-beginx)/13;
      diffy=(endy-beginy)/4;
      clrButton = 6;
VAR   oldCol:CARDINAL;
      newUnits:CountryRe;
BEGIN
  oldCol:=SetBkColor(6);
  Rectangle (beginx, beginy, endx, endy, clrButton, TRUE);
  Rectangle (beginx, beginy, endx, endy, _clrBLACK, FALSE);
  Rectangle (beginx+1, beginy+1, endx-1, endy-1, _clrBLACK, FALSE);
  DrawButton(beginx+1*diffx,beginy+1*diffy,beginx+4*diffx,beginy+3*diffy,_clrLIGHTYELLOW,'Buy units');
  DrawButton(beginx+5*diffx,beginy+1*diffy,beginx+8*diffx,beginy+3*diffy,_clrLIGHTYELLOW,'Upgrade');
  DrawButton(beginx+9*diffx,beginy+1*diffy,beginx+12*diffx,beginy+3*diffy,_clrLIGHTYELLOW,'Cancel');
  oldCol:=SetBkColor(oldCol);
  LOOP
   IF UpdateMouse() THEN
     IF IsButtonPressed(LEFT_BUTTON) THEN
       IF ((GetMouseX()>=beginx+1*diffx) AND (GetMouseX()<=beginx+12*diffx) AND (GetMouseY()>=beginy+1*diffy) AND (GetMouseY()<=beginy+3*diffy)) THEN
         CASE GetMouseX() OF
	   beginx+1*diffx..beginx+4*diffx  :  gNewUnitsBo:=PopUpBuy(gActivePlayer);EXIT;
	  |beginx+5*diffx..beginx+8*diffx  :  PopUpUpgrade(gActivePlayer);EXIT;
	  |beginx+9*diffx..beginx+12*diffx :  EXIT;
	   ELSE;
	 END;
       END;
     END; (* IsButtonPressed *)
   END; (* UpdateMouse *)
  END; (* LOOP *)
  ClearScreen(0);
  DrawSavedBitmap((SSX-MSX)/2, (SSY-MSY)/5, gbmpID);
  DrawBackGround;
  DrawScreen;
  IF gNewUnitsBo THEN Output('Put new units where?');
  END; (* IF *)

  LOOP
    IF UpdateMouse() THEN
        IF IsButtonPressed(LEFT_BUTTON) THEN
	  IF ((GetMouseX()>=(SSX-MSX)/2) AND (GetMouseX()<=(SSX-MSX)/2+MSX) AND (GetMouseY()<=(SSY-MSY)/5+MSY) AND (GetMouseY()>=(SSY-MSY)/5) AND gNewUnitsBo) THEN	
	    gCountryClicked:=CheckWhichCountryClicked(GetMouseX(),GetMouseY());
	    IF gCountryClicked#NBR_COUNTRIES+1 THEN
	      IF gEuropeAr[gCountryClicked]^.owner=gActivePlayer THEN
	        gEuropeAr[gCountryClicked]^.Peas:=gEuropeAr[gCountryClicked]^.Peas+gNewUnits.Peas;
	        gEuropeAr[gCountryClicked]^.Inf:=gEuropeAr[gCountryClicked]^.Inf+gNewUnits.Inf;
	        gEuropeAr[gCountryClicked]^.Cav:=gEuropeAr[gCountryClicked]^.Cav+gNewUnits.Cav;
	        gEuropeAr[gCountryClicked]^.Can:=gEuropeAr[gCountryClicked]^.Can+gNewUnits.Can;
	        gNewUnitsBo:=FALSE;
		gActiveCountry:=gCountryClicked;
	      ELSE Output('Must be country of your own!'); Delay(1000); Output('Put new units where?');
	      END; (* IF correct owner *)
	    ELSE Output('Put new units where?');
	    END;
	  ELSE;
	  END; (* X, Y, TRUE *)
	  IF gNewUnitsBo=FALSE THEN EXIT
	  END;
	END; (* IsButtonPressed *)
    END; (* UpdateMouse *)
  END; (* LOOP *)
  ClearScreen(0);
  DrawSavedBitmap((SSX-MSX)/2, (SSY-MSY)/5, gbmpID);
  DrawBackGround;
  DrawScreen;
END PopUpChoose;

BEGIN    (* MAIN PROGRAM *)                          (* Sybren *)
  IF InitSound(TRUE) THEN
    WrStr("Sound works on this computer"); WrLn;
  ELSE
    WrStr("Sound doesn't work on this computer..."); WrLn;
  END;
  IF NOT InitMouseGraphWindow(SSX,SSY) THEN
    WrStr("Sorry, mouse & graphics don't work");WrLn;
    RETURN;
  END;
REPEAT
gGameStateBo:=IntroScreen();
IF gGameStateBo THEN
  PlaySoundEvent(STILTE);
  ClearScreen(0);
  InitCountries;
  DivideEurope(NBR_PLAYERS);
  FOR i:=0 TO 17 DO
  gEuropeAr[i]^.Peas:=10;
  gEuropeAr[i]^.Inf:=8;
  gEuropeAr[i]^.Cav:=4;
  gEuropeAr[i]^.Can:=1;
  gEuropeAr[i]^.drawCoord:=ConvertCoordinates(gEuropeAr[i]^.x,gEuropeAr[i]^.y,gEuropeAr[i]^.name);
  END; (* FOR i *)
  gPlayerAr[1].money:=7000;
  gPlayerAr[2].money:=5000;
  gActiveCountry:=5;
  gActivePlayer:=1;
  gbmpID:=0;
  DrawBackGround;
  DrawScreen;
  gGameStateBo:=TRUE;
  gMoveAttackBo:=FALSE;
  gNewUnitsBo:=FALSE;
  LOOP   (* Loop game *)
    gNbrMoves:=0;
    LOOP  (* Loop 1 Player *)
      gEndTurnBo:=TRUE;
      IF UpdateMouse() THEN
        IF IsButtonPressed(LEFT_BUTTON) THEN	
          CASE GetMouseY() OF
            (SSY-MSY)/5..(SSY-MSY)/5+MSY:                              (* map area clicked *)
	      IF ((GetMouseX()>=(SSX-MSX)/2)AND(GetMouseX()<=((SSX-MSX)/2)+MSX))THEN
	        gCountryClicked:=CheckWhichCountryClicked(GetMouseX(),GetMouseY());
	        IF gCountryClicked=NBR_COUNTRIES+1 THEN                 (* no country selected *)
                 DrawBorderCountry(gEuropeAr[gActiveCountry]^,_clrBLACK);
		 DrawScreen;
	          Output('Select a country');
		  gMoveAttackBo:=FALSE;
                END; (* IF = *)
	        IF gCountryClicked#NBR_COUNTRIES+1 THEN                 (* given country selected *)
	          IF gMoveAttackBo=FALSE THEN
		    DrawBorderCountry(gEuropeAr[gActiveCountry]^,_clrBLACK);
	            gActiveCountry:=gCountryClicked;
		    DrawBorderCountry(gEuropeAr[gActiveCountry]^, _clrLIGHTGREEN);
		    DrawScreen;
	            UpdateAfterCountryClicked();
		  ELSE
		    CASE MoveAttackPossible() OF
		      0   : Output('Not in vicinity');		
		     |1   : Output('Select units to attack with'); gAttackBo:=TRUE;Battle;
		            IF CheckForWinner()
			      THEN
			        gWinnerBo:=TRUE;
			        gGameStateBo:=FALSE;
			      EXIT;
			    END;
		     |2   : Output('Select units to move'); gAttackBo:=FALSE;Move;
		     END; (* CASE MAP *)
		     gMoveAttackBo:=FALSE;		
		  END; (* mAB *)		
	        END; (* IF # *)
	      END; (* IF x *)	      	
           |INITY..INITY+11*DIFFY :                                                    (* menu area clicked *)
              CASE GetMouseX() OF
	        INITX..INITX+4*DIFFX:
		  CASE GetMouseY() OF		
		    INITY+4*DIFFY..INITY+7*DIFFY  : PopUpChoose();
		  ELSE;
		  END; (* CASE gY *)
   	       |INITX+10*DIFFX..INITX+12*DIFFX:
   	          CASE GetMouseY() OF
		    INITY..INITY+3*DIFFY          : PrepareMoveAttack(gActiveCountry);   (* standing by for country to attack / move to *)
	       	   |INITY+4*DIFFY..INITY+7*DIFFY  : EndTurn(gActivePlayer);              (* End Turn clicked, change of player *)
		   |INITY+8*DIFFY..INITY+11*DIFFY : EndGame;                             (* Quit clicked, end of game *)
		  ELSE;
		  END; (* CASE gY *)
	        ELSE;
              END; (* CASE gX *)
	    ELSE;
          END; (* CASE gY *)
	  IF gNbrMoves=3 THEN EndTurn(gActivePlayer);
          END; (* IF gNbrMoves *)
	  IF (gEndTurnBo=FALSE) THEN EXIT;
	  END; (* IF gEndTurnBo *)	
        END; (* IF IsButtonPressed *)
      END; (* IF UpdateMouse *)
    END; (* LOOP 1 Player *)
    IF (gGameStateBo=FALSE) THEN gGameStateBo:=TRUE; EXIT;
    END; (* gGameStateBo *)
    DrawScreen;
  END; (* Loop Game *)
  InitUnits;
END; (* IF IntroScreen *)
UNTIL (NOT gGameStateBo) OR (NOT OutroScreen(gWinnerBo,gEuropeAr[1]^.owner));

END ContinentalScreen.
