IMPLEMENTATION MODULE StandardMouse;
 <* M2EXTENSIONS + *>  <* GUI + *>
IMPORT Windows;
FROM IO IMPORT WrStr,WrLn;
FROM SYSTEM IMPORT ADR;
FROM Graph IMPORT Init;

CONST
	szAppName = "M";
VAR x,y  : INTEGER;
		msg  : Windows.MSG;
		hwnd : Windows.HWND;
		wc   : Windows.WNDCLASSEX;
		changed: BOOLEAN;
		knoppen: ARRAY MouseButton OF BOOLEAN;

PROCEDURE [Windows.CALLBACK] WndProc (hwnd : Windows.HWND;iMsg : Windows.UINT; wParam : Windows.WPARAM; lParam : Windows.LPARAM) : Windows.LRESULT;
VAR p : Windows.POINTS;
BEGIN
  CASE (iMsg) OF
    | Windows.WM_DESTROY     :
			Windows.PostQuitMessage (0);
      RETURN 0;
		| Windows.WM_MOUSEMOVE   :
			p := Windows.MAKEPOINTS(lParam);
			x := p.x;
			y := p.y;
			changed := TRUE;
		  RETURN 0;
		| Windows.WM_LBUTTONUP :
			knoppen[LEFT_BUTTON] := TRUE;
			changed    := TRUE;
			RETURN 0;
		| Windows.WM_MBUTTONUP :
			knoppen[MIDDLE_BUTTON] := TRUE;
			changed    := TRUE;
			RETURN 0;
		| Windows.WM_RBUTTONUP :
			knoppen[RIGHT_BUTTON] := TRUE;
			changed    := TRUE;
			RETURN 0;


	ELSE
  RETURN Windows.DefWindowProc (hwnd, iMsg, wParam, lParam);
	END;
END WndProc;

PROCEDURE InitApplication(): BOOLEAN;
BEGIN
  wc.cbSize        := SIZE(wc);
  wc.style         := Windows.CS_SET{};
  wc.lpfnWndProc   := WndProc;
  wc.cbClsExtra    := 0;
  wc.cbWndExtra    := 0;
  wc.hInstance     := Windows.MyInstance();
  wc.hIcon         := Windows.LoadIcon (NIL, Windows.IDI_APPLICATION);
  wc.hCursor       := Windows.LoadCursor (NIL, Windows.IDC_ARROW);
  wc.hbrBackground := Windows.CreateSolidBrush(000h);
  wc.lpszMenuName  := NIL;
  wc.lpszClassName := ADR(szAppName);
  wc.hIconSm       := Windows.LoadIcon (NIL,Windows.IDI_APPLICATION);

  RETURN Windows.RegisterClassEx(wc)#0;
END InitApplication;

PROCEDURE InitMainWindow(x,y,w,h:CARDINAL) : BOOLEAN;
BEGIN
	IF (Init(x,y,w,h)) THEN
  hwnd := Windows.CreateWindow (szAppName,"",Windows.WS_CHILD,x,y,w,h,Windows.FindWindow("GraphWnd",NIL),NIL,Windows.MyInstance(),NIL);
  Windows.ShowWindow(hwnd, Windows.SW_SHOWDEFAULT);
  Windows.UpdateWindow(hwnd);
  RETURN TRUE;
	END;
	RETURN FALSE;
END InitMainWindow;

PROCEDURE InitMouseGraphWindow(width,height:CARDINAL):BOOLEAN;
BEGIN
  RETURN (InitApplication()  AND  InitMainWindow(1, 1, width+8, height+35));
END InitMouseGraphWindow;

PROCEDURE UpdateMouse():BOOLEAN;
BEGIN
	changed := FALSE;
	knoppen[LEFT_BUTTON] := FALSE;
	knoppen[MIDDLE_BUTTON] := FALSE;
	knoppen[RIGHT_BUTTON] := FALSE;
	WHILE (Windows.PeekMessage(msg,NIL,Windows.WM_MOUSEFIRST,Windows.WM_MOUSELAST,Windows.PM_REMOVE)) DO
		Windows.TranslateMessage(msg);
		Windows.DispatchMessage(msg);
	END;
	RETURN changed;
END UpdateMouse;
PROCEDURE GetMouseX():CARDINAL;
BEGIN
  RETURN x;
END GetMouseX;

PROCEDURE GetMouseY(): CARDINAL;
BEGIN
  RETURN y;
END GetMouseY;
PROCEDURE IsButtonPressed(button: MouseButton):BOOLEAN;
BEGIN
	RETURN knoppen[button];
END IsButtonPressed;

END StandardMouse.

